Class constructor($name : Text; $spec : Object)
	
	This:C1470.name:=$name
	This:C1470.spec:=$spec
	This:C1470.method:=$spec["method"]
	This:C1470.title:=Choose:C955($spec["title"]#Null:C1517; $spec["title"]; This:C1470.name)
	//This.iconPath:=Choose($spec.icon#Null; $spec.icon; "")
	This:C1470.icon:=$spec["icon"]
	
Function validate()->$valid : Boolean
	
	$valid:=False:C215
	
	C_OBJECT:C1216($check)
	$check:=This:C1470._checkMethod()
	
	If ($check.exists)
		
		If ($check.shared)
			
			$valid:=True:C214
			
		Else 
			
			If (Not:C34(Is compiled mode:C492(*)))
				ALERT:C41(\
					"[ImgCtl]\n\nProject method '"+This:C1470.method\
					+"' which is registered for handling action '"+This:C1470.name\
					+"' was not found in either the Q2ImgControl component or the host database.")
			End if 
			
		End if 
		
	Else 
		
		If (Not:C34(Is compiled mode:C492(*)))
			ALERT:C41(\
				"[ImgCtl]\n\nProject method '"+This:C1470.method\
				+"' which is registered for handling action '"+This:C1470.name\
				+"' was not found in either the Q2ImgControl component or the host database.")
		End if 
		
	End if 
	
	
Function _checkMethod()->$check : Object
	
	$check:=New object:C1471
	$check.exists:=False:C215
	$check.shared:=False:C215
	
	If (Is compiled mode:C492(*))
		
		$check.exists:=True:C214
		$check.shared:=True:C214
		
	Else 
		
		If (Comp_MethodExists(This:C1470.method; True:C214))  // Host database
			
			$check.exists:=True:C214
			$check.shared:=METHOD Get attribute:C1169(This:C1470.method; Attribute shared:K72:10; *)
			
		Else 
			
			If (Comp_MethodExists(This:C1470.method; False:C215))  // Component
				
				$check.exists:=True:C214
				$check.shared:=METHOD Get attribute:C1169(This:C1470.method; Attribute shared:K72:10)
				
			End if 
			
		End if 
		
	End if 
	
	
Function call($message : Text; $context : Object)->$result : Object
	
	$result:=Action_Call(This:C1470.name; This:C1470.method; $message; $context)
	
	