Class extends Widget

Class constructor($controlName : Text)
	
	Super:C1705($controlName)
	
	This:C1470.controls:=Null:C1517
	If (This:C1470.controlName#"")
		This:C1470.innerWidget:=cs:C1710.TestSubWidget.new(This:C1470)
	End if 
	
	
	
Function setup($config : Variant)->$success : Boolean
	
	$success:=Super:C1706.setup($config)
	
	
Function _buildControls()->$success : Boolean
	
	This:C1470.controls:=New collection:C1472()
	
	var $idx : Integer
	For ($idx; 0; This:C1470.config.numButtons-1)
		
		var $control : Object
		$control:=New object:C1471()
		$control.name:="button_"+String:C10($idx)
		$control.title:="Btn #"+String:C10($idx)
		$control.bounds:=cs:C1710.Rect.new(0; 0; 0; 0)
		
		This:C1470.controls.push($control)
		
	End for 
	
	$success:=True:C214
	
	
Function _buildLayout()->$success : Boolean
	
	var $buttonWidth; $buttonHeight : Integer
	$buttonWidth:=80
	$buttonHeight:=21
	
	var $space : Integer
	$space:=20
	
	var $curX; $curY : Integer
	$curX:=0
	$curY:=0
	
	var $idx : Integer
	For ($idx; 0; This:C1470.controls.length-1)
		
		var $bounds : cs:C1710.Rect
		$bounds:=cs:C1710.Rect.new($curX+$space; $curY+$space; $buttonWidth; $buttonHeight)
		This:C1470.controls[$idx].bounds:=$bounds
		
		$curX:=$bounds.x+$bounds.width
		$curY:=$curY
		
	End for 
	
	$success:=True:C214
	
	
	//Function _buildForm()->$success : Boolean
	
	//var $idx : Integer
	//For ($idx; 0; This.controls.length-1)
	
	//var $control : Object
	//$control:=This.controls[$idx]
	
	//var $bounds : cs.Rect
	//$bounds:=$control.bounds
	
	//OBJECT DUPLICATE(*; "button"; $control.name)
	
	//OBJECT SET COORDINATES(*; $control.name; \
								$bounds.x; \
								$bounds.y; \
								$bounds.x+$bounds.width; \
								$bounds.y+$bounds.height)
	
	//OBJECT SET VISIBLE(*; $control.name; True)
	
	//End for 
	
	//$success:=True
	
	
	//Function _applyLayout()->$success : Boolean
	
	//var $idx : Integer
	//For ($idx; 0; This.controls.length-1)
	
	//var $control : Object
	//$control:=This.controls[$idx]
	
	//var $bounds : cs.Rect
	//$bounds:=$control.bounds
	
	//OBJECT SET COORDINATES(*; $control.name; \
								$bounds.x; \
								$bounds.y; \
								$bounds.x+$bounds.width; \
								$bounds.y+$bounds.height)
	
	//End for 
	
	//var $width; $height : Integer
	//OBJECT GET SUBFORM CONTAINER SIZE($width; $height)
	
	//OBJECT SET COORDINATES(*; "frame"; 0; 0; $width; $height)
	//OBJECT SET RGB COLORS(*; "frame"; This.config.color)
	
	//$success:=True
	
	