Class extends Part

Class constructor($name : Text; $spec : Object; $style : Object; $userActions : Object)
	
	Super:C1705($name; "ts_"; $spec; $style)
	
	This:C1470.tools:=New collection:C1472()
	
	var $idx : Integer  // Generate unique tool names
	$idx:=0
	
	var $toolSpec : Variant
	For each ($toolSpec; This:C1470.spec["tools"])
		
		var $toolName : Text
		$toolName:=This:C1470.name+"-tool-"+String:C10($idx)
		
		var $tool : cs:C1710.Tool
		$tool:=cs:C1710.Tool.new($toolName; $toolSpec; $style; $userActions)
		
		If ($tool.validate())
			This:C1470.tools.push($tool)
			$idx:=$idx+1
		End if 
		
	End for each 
	
	
Function validate()->$valid : Boolean
	
	$valid:=(This:C1470.tools.length>0)
	
	