//%attributes = {"invisible":true}
C_TEXT:C284($1; $resourceFileSubPath)
C_OBJECT:C1216($0; $resourceFileFSRef)

$resourceFileSubPath:=$1

C_TEXT:C284($controllerDirSubPath)
$controllerDirSubPath:="Q2Pix/Q2ImgControl"

// First look in host resources
C_OBJECT:C1216($resourceFSRef)
$resourceFSRef:=FSRef_InitWithHostResource($controllerDirSubPath+"/"+$resourceFileSubPath)

If (OB Is defined:C1231($resourceFSRef) & FSRef_IsFile($resourceFSRef))
	$resourceFileFSRef:=$resourceFSRef
Else 
	// If not in host resources check component
	
	C_TEXT:C284($resourcesDirPath)
	$resourcesDirPath:=Get 4D folder:C485(Current resources folder:K5:16)
	
	C_OBJECT:C1216($resourcesDirRef)
	$resourcesDirRef:=FSRef_InitWithSystemPath($resourcesDirPath)
	
	C_OBJECT:C1216($controllerDirRef)
	$controllerDirRef:=FSRef_AppendSubPath($resourcesDirRef; $controllerDirSubPath)
	
	$resourceFSRef:=FSRef_AppendSubPath($controllerDirRef; $resourceFileSubPath)
	If (FSRef_Exists($resourceFSRef) & FSRef_IsFile($resourceFSRef))
		$resourceFileFSRef:=$resourceFSRef
	End if 
	
End if 

$0:=$resourceFileFSRef
