//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)

$context:=$1

ASSERT:C1129(OB Is defined:C1231($context))

C_OBJECT:C1216($containerSize)
$containerSize:=FormObj_GetSubformContainerSize 

C_LONGINT:C283($containerWidth;$containerHeight)
$containerWidth:=SizeObj_GetWidth ($containerSize)
$containerHeight:=SizeObj_GetHeight ($containerSize)

OBJECT SET VISIBLE:C603(*;"sep@";False:C215)

FormObj_SetRect ("sizer";RectObj_New (0;0;8000;8000))

C_LONGINT:C283($menubarHeight;$toolbarHeight)
$menubarHeight:=Menubar_Layout ($context)
$toolbarHeight:=Toolbar_Layout ($context)

C_BOOLEAN:C305($menubarVisible;$toolbarVisible)
$menubarVisible:=OB Get:C1224($context;"_menubar_visible";Is boolean:K8:9)
$toolbarVisible:=OB Get:C1224($context;"_toolbar_visible";Is boolean:K8:9)

If (Not:C34($menubarVisible))
	OBJECT SET VISIBLE:C603(*;"menu_@";False:C215)
	$menubarHeight:=0
End if 

If (Not:C34($toolbarVisible))
	OBJECT SET VISIBLE:C603(*;"toolset_@";False:C215)
	$toolbarHeight:=0
End if 

C_LONGINT:C283($controlPartsHeight)
$controlPartsHeight:=0

If (($menubarHeight>0) & ($toolbarHeight>0))
	
	FormObj_SetRect ("sep";RectObj_New (0;$menubarHeight+1;$containerWidth;0))
	OBJECT SET VISIBLE:C603(*;"sep";True:C214)
	
	FormObj_SetRect ("sep2";RectObj_New (0;$menubarHeight+$toolbarHeight+1;$containerWidth;0))
	OBJECT SET VISIBLE:C603(*;"sep2";True:C214)
	
	OBJECT MOVE:C664(*;"toolset_@";0;$menubarHeight+2)
	$controlPartsHeight:=$menubarHeight+$toolbarHeight+2
	
Else 
	If (($menubarHeight+$toolbarHeight)>0)
		
		FormObj_SetRect ("sep";RectObj_New (0;$menubarHeight+$toolbarHeight+1;$containerWidth;0))
		OBJECT SET VISIBLE:C603(*;"sep";True:C214)
		
		$controlPartsHeight:=$menubarHeight+$toolbarHeight+1
	Else 
		$controlPartsHeight:=$menubarHeight+$toolbarHeight
	End if 
End if 

C_BOOLEAN:C305($sidebarVisible)
$sidebarVisible:=OB Get:C1224($context;"_sidebar_visible";Is boolean:K8:9)
OBJECT SET VISIBLE:C603(*;"_sidebar";$sidebarVisible)

C_LONGINT:C283($sidebarWidth)
$sidebarWidth:=OB Get:C1224($context;"_sb_width";Is longint:K8:6)

C_OBJECT:C1216($sidebarRect)
  //$sidebarRect:=RectObj_New (Choose($sidebarVisible;0;-300);\
$controlPartsHeight;$sidebarWidth;$containerHeight-$controlPartsHeight)
$sidebarRect:=RectObj_New (0;\
$controlPartsHeight;$sidebarWidth;$containerHeight-$controlPartsHeight)

FormObj_SetRect ("_sidebar";$sidebarRect)

If ($sidebarVisible)
	Control_SetTasking (10)
End if 

C_OBJECT:C1216($areaFrame)
If ($sidebarVisible)
	$areaFrame:=RectObj_New ($sidebarWidth;$controlPartsHeight;$containerWidth-$sidebarWidth;$containerHeight-$controlPartsHeight)
Else 
	$areaFrame:=RectObj_New (0;$controlPartsHeight;$containerWidth;$containerHeight-$controlPartsHeight)
End if 

OB SET:C1220($context;"_area_frame";$areaFrame)

FormObj_SetRect ("sizer";RectObj_New (0;0;$containerWidth;$containerHeight))

