//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$imgDocRef)
C_LONGINT:C283($3;$frameIdx)
C_LONGINT:C283($0;$success)

$context:=$1
$imgDocRef:=$2
If (Count parameters:C259>2)
	$frameIdx:=$3
End if 
If ($frameIdx=0)
	$frameIdx:=1
End if 

$success:=0

ASSERT:C1129(OB Is defined:C1231($context))

C_LONGINT:C283($areaRef)
$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)

OB REMOVE:C1226($context;"_format_info")

  // Just to check for an already assigned doc
C_TEXT:C284($existingDoc)
$existingDoc:=ImgArea_GetDocument:P11667:41 ($areaRef)
If ($existingDoc#"")
	ImgObj_Release:P11667:133 ($existingDoc)
End if 

$success:=ImgArea_SetDocument:P11667:40 ($areaRef;$imgDocRef;$frameIdx)
If ($success=1)
	
	  // Post messages
	C_OBJECT:C1216($message)
	  // If there was a doc assigned, first post unload message
	If ($existingDoc#"")
		OB SET:C1220($message;"what";"ImageUnloaded")
		Queue_PostMessage_S ($context;$message)
	End if 
	
	  // Update format info
	C_TEXT:C284($format)
	$format:=ImgDoc_GetFormat:P11667:9 ($imgDocRef)
	
	C_OBJECT:C1216($formatInfo)
	$formatInfo:=ImgFormat_GetInfo ($format)
	
	If (OB Is defined:C1231($formatInfo))
		OB SET:C1220($context;"_format_info";$formatInfo)
	End if 
	
	  // Post load message
	OB SET:C1220($message;"what";"ImageLoaded")
	Queue_PostMessage_S ($context;$message)
	
End if 

$0:=$success
