//%attributes = {"invisible":true,"shared":true}
#DECLARE($actionName : Text; $message : Text; $context : cs:C1710.CallbackContext)->$status : Object

$status:=New object:C1471
$status.enabled:=True:C214

var $widget : cs:C1710.ImgWidget
$widget:=$context.imgControl

Case of 
	: ($actionName="img_sidebar_hide")
		
		Case of 
			: ($message="status")
				
				var $sidebarVisible : Boolean
				$sidebarVisible:=$widget.isPartVisible("sidebar")
				
				$status.checked:=Not:C34($sidebarVisible)
				
			: ($message="action")
				
				$widget.setPartVisible("sidebar"; False:C215)
				
		End case 
		
	: ($actionName="img_sidebar_thumbs")
		
		Case of 
			: ($message="status")
				
				var $sidebarVisible : Boolean
				$sidebarVisible:=$widget.isPartVisible("sidebar")
				
				var $sidebarView : Text
				$sidebarView:=$widget.getSidebarView()
				
				$status.checked:=($sidebarVisible & ($sidebarView="thumbs"))
				
			: ($message="action")
				
				var $sidebarVisible : Boolean
				$sidebarVisible:=$widget.isPartVisible("sidebar")
				If (Not:C34($sidebarVisible))
					$widget.setPartVisible("sidebar"; True:C214)
				End if 
				
				var $sidebarView : Text
				$sidebarView:=$widget.getSidebarView()
				If ($sidebarView#"thumbs")
					$widget.setSidebarView("thumbs")
				End if 
				
		End case 
		
	: ($actionName="img_sidebar_toc")
		
		Case of 
			: ($message="status")
				
				var $sidebarVisible : Boolean
				$sidebarVisible:=$widget.isPartVisible("sidebar")
				
				var $sidebarView : Text
				$sidebarView:=$widget.getSidebarView()
				
				$status.checked:=($sidebarVisible & ($sidebarView="TOC"))
				
			: ($message="action")
				
				var $sidebarVisible : Boolean
				$sidebarVisible:=$widget.isPartVisible("sidebar")
				If (Not:C34($sidebarVisible))
					$widget.setPartVisible("sidebar"; True:C214)
				End if 
				
				var $sidebarView : Text
				$sidebarView:=$widget.getSidebarView()
				If ($sidebarView#"TOC")
					$widget.setSidebarView("TOC")
				End if 
				
		End case 
		
End case 
