//%attributes = {"invisible":true,"shared":true}
C_TEXT:C284($1;$message)
C_TEXT:C284($2;$command)
C_OBJECT:C1216($3;$env)
C_OBJECT:C1216($0;$status)

$message:=$1
$command:=$2
$env:=$3

C_OBJECT:C1216($context)
$context:=$env.context

C_TEXT:C284($docRef;$docFormat)
$docRef:=$env.docRef
$docFormat:=$env.docFormat

C_LONGINT:C283($frameIdx;$frameCount)
$frameIdx:=$env.frameIndex
$frameCount:=$env.frameCount

$status:=New object:C1471

Case of 
	: ($command="img_meta")
		
		Case of 
			: ($message="status")
				
				C_TEXT:C284($xmpDataRef)
				If ($docFormat#"PDF")
					$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27 ($docRef;$frameIdx)
				Else 
					$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32 ($docRef)
				End if 
				
				$status.enabled:=($xmpDataRef#"")
				
				If ($xmpDataRef#"")
					ImgObj_Release:P11667:133 ($xmpDataRef)
				End if 
				
			: ($message="action")
				
				C_TEXT:C284($xmpDataRef)
				If ($docFormat#"PDF")
					$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27 ($docRef;$frameIdx)
				Else 
					$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32 ($docRef)
				End if 
				
				If ($xmpDataRef#"")
					
					C_TEXT:C284($filePath;$windowTitle)
					$filePath:=ImgDoc_GetFilePath ($docRef)
					
					If ($filePath#"")
						C_OBJECT:C1216($fileObject)
						$fileObject:=File:C1566($filePath;fk posix path:K87:1)
						$windowTitle:="XMP Metadata: "+$fileObject.name
					Else 
						$windowTitle:="XMP Metadata"
					End if 
					
					If ($docFormat#"PDF")
						If ($frameCount>1)
							$windowTitle:=$windowTitle+" / Frame "+String:C10($frameIdx)
						End if 
					End if 
					
					C_OBJECT:C1216($options)
					$options:=New object:C1471()
					$options.WindowTitle:=$windowTitle
					$options.DevMode:=(Shift down:C543 & Not:C34(Is compiled mode:C492(*)))
					
					C_LONGINT:C283($success)
					$success:=XMPDlog_EditData ($xmpDataRef;$options)
					If ($success=1)
						
						If ($docFormat#"PDF")
							RasterFrame_SetXMPData ($docRef;$frameIdx;$xmpDataRef)
						Else 
							  // FIXME: PDF XMP assignment
						End if 
					End if 
					
					ImgObj_Release:P11667:133 ($xmpDataRef)
				End if 
				
		End case 
		
End case 

$0:=$status
