//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.

  // @desc: Cleanup a ImgControl form object.

  // @doc: Cleanup a ``ImgControl`` form object.
  //
  // This method must be called when the ``ImgControl`` instance is destroyed
  // in order to clean up the widget's internal context.
  //
  // Typically called during the ``On Unload`` event of the host form.
  //
  // .. note:: Forms created in the Form Editor do not have the ``On Unload``
  //           event checked by default, so make sure that the event in enabled
  //           in the form properties.
  //


ASSERT:C1129(Count parameters:C259>=1)

$controlName:=$1

C_POINTER:C301($contextPtr)
$contextPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)
If (Not:C34(Is nil pointer:C315($contextPtr)))
	
End if 
