//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_LONGINT:C283($0;$frameIdx)  // @param: The image frame index.

  // @desc: Return the index of the image frame displayed in a ImgControl form object.

  // @doc: Return the index of the image frame displayed in the ``ImgControl`` form object named ``controlName``.
  //
  // The frame index is returned in ``frameIdx``.
  //

ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1
$frameIdx:=0

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_LONGINT:C283($areaRef)
	$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)
	
	$frameIdx:=ImgArea_GetFrameIndex:P11667:42 ($areaRef)
	
End if 

$0:=$frameIdx
