//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.

  // @desc: Update the state of a ImgControl form object.

  // @doc: Update the state of the ``ImgControl`` named ``controlName``
  // for changes made "behind its back".
  // 
  // If any changes are made to the plug-in area directly or to the image document
  // currently assigned to the control and plug-in area, the ``ImgControl`` has to
  // be notified. Call this method to let the control update the state of
  // its internal parts.

ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Sync_S";*;$context)
	EXECUTE METHOD IN SUBFORM:C1085($controlName;"Control_UpdateState_S";*;$context)
	
End if 
