//%attributes = {}
C_OBJECT:C1216($1;$toolbar)  // "toolbar" in control config
C_OBJECT:C1216($2;$metrics)
C_LONGINT:C283($3;$formWidth)
C_COLLECTION:C1488($0;$toolbarRows)

$toolbar:=$1
$metrics:=$2
$formWidth:=$3

$toolbarRows:=New collection:C1472(New collection:C1472)

C_LONGINT:C283($usableWidth;$remainingWidth)
$usableWidth:=$formWidth-(2*$metrics.toolset.marginX)
$remainingWidth:=$usableWidth

C_LONGINT:C283($curX;$curY)
$curX:=$metrics.toolset.marginX
$curY:=$metrics.toolset.marginY

C_OBJECT:C1216($toolset)
C_LONGINT:C283($idx)
For ($idx;0;$toolbar.toolsets.length-1)
	
	$toolset:=$toolbar.toolsets[$idx]
	
	C_LONGINT:C283($toolsetWidth)
	$toolsetWidth:=ToolsetNG_GetWidth ($toolset;$metrics)
	
	C_BOOLEAN:C305($newRow)
	$newRow:=$toolset.visible & ($toolsetWidth>$remainingWidth)
	If ($newRow)
		
		$toolbarRows.push(New collection:C1472)
		
		$remainingWidth:=$usableWidth
		
		$curX:=$metrics.toolset.marginX
		$curY:=$curY+$metrics.toolset.height+$metrics.toolset.marginY
		
	End if 
	
	C_OBJECT:C1216($toolsetLayout)
	$toolsetLayout:=New object:C1471
	$toolsetLayout.toolset:=$toolset
	
	$toolsetLayout.bounds:=New object:C1471
	If ($toolset.visible)
		$toolsetLayout.bounds.x:=$curX
		$toolsetLayout.bounds.y:=$curY
	Else 
		$toolsetLayout.bounds.x:=0
		$toolsetLayout.bounds.y:=0
	End if 
	$toolsetLayout.bounds.width:=$toolsetWidth
	$toolsetLayout.bounds.height:=$metrics.toolset.height
	
	$toolsetLayout.tools:=New collection:C1472
	
	$toolbarRows[$toolbarRows.length-1].push($toolsetLayout)
	
	If ($toolset.visible)
		$curX:=$curX+$toolsetWidth+$metrics.toolset.marginX
		$remainingWidth:=$remainingWidth-$toolsetWidth-$metrics.toolset.marginX
	End if 
	
	C_LONGINT:C283($curToolX)
	$curToolX:=$toolsetLayout.bounds.x+$metrics.tool.marginX
	
	C_LONGINT:C283($toolIdx)
	For ($toolIdx;0;$toolset.tools.length-1)
		
		C_OBJECT:C1216($tool)
		$tool:=$toolset.tools[$toolIdx]
		
		C_OBJECT:C1216($toolLayout)
		$toolLayout:=New object:C1471
		$toolLayout.tool:=$tool
		
		$toolLayout.bounds:=New object:C1471
		If ($tool.type="input")  // center vertically
			
			$toolLayout.bounds.x:=$curToolX
			$toolLayout.bounds.y:=$toolsetLayout.bounds.y+$metrics.input.marginY
			If ($tool.width#Null:C1517)
				$toolLayout.bounds.width:=$tool.width
			Else 
				$toolLayout.bounds.width:=$metrics.input.width
			End if 
			$toolLayout.bounds.height:=$metrics.input.height
			
		Else 
			
			$toolLayout.bounds.x:=$curToolX
			$toolLayout.bounds.y:=$toolsetLayout.bounds.y+$metrics.tool.marginY
			If ($tool.width#Null:C1517)
				$toolLayout.bounds.width:=$tool.width
			Else 
				$toolLayout.bounds.width:=$metrics.tool.width
			End if 
			$toolLayout.bounds.height:=$metrics.tool.height
		End if 
		
		$toolsetLayout.tools.push($toolLayout)
		
		$curToolX:=$curToolX+$toolLayout.bounds.width+$metrics.tool.marginX
		
		If ($tool.type="input")
			$toolLayout.bounds.x:=$toolLayout.bounds.x+2
			$toolLayout.bounds.width:=$toolLayout.bounds.width-4
		End if 
		
	End for 
	
End for 

$0:=$toolbarRows
