//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_LONGINT:C283($0;$toolbarHeight)

$context:=$1
$toolbarHeight:=0

ASSERT:C1129(OB Is defined:C1231($context))

C_OBJECT:C1216($containerSize)
$containerSize:=FormObj_GetSubformContainerSize 

C_LONGINT:C283($containerWidth)
$containerWidth:=SizeObj_GetWidth ($containerSize)

OBJECT SET VISIBLE:C603(*;"toolset_@";False:C215)

  //==============================================
  // Toolbar layout
  //==============================================

C_LONGINT:C283($masterToolsetHeight)
$masterToolsetHeight:=OB Get:C1224($context;"_toolset_height";Is longint:K8:6)
If ($masterToolsetHeight=0)
	$masterToolsetHeight:=RectObj_GetHeight (FormObj_GetRect ("master_toolset"))
	OB SET:C1220($context;"_toolset_height";$masterToolsetHeight)
End if 

C_OBJECT:C1216($toolbar)
$toolbar:=OB Get:C1224($context;"_toolbar";Is object:K8:27)

ARRAY TEXT:C222($toolsetObjectNames;0)
OB GET PROPERTY NAMES:C1232($toolbar;$toolsetObjectNames)
SORT ARRAY:C229($toolsetObjectNames)

C_LONGINT:C283($toolsetCount)
$toolsetCount:=Size of array:C274($toolsetObjectNames)

C_LONGINT:C283($curLeft;$curTop)
$curLeft:=0
$curTop:=0

C_LONGINT:C283($idx)

For ($idx;1;$toolsetCount)
	
	C_TEXT:C284($objectName)
	$objectName:=$toolsetObjectNames{$idx}
	
	C_OBJECT:C1216($toolsetSpec)
	$toolsetSpec:=OB Get:C1224($toolbar;$objectName;Is object:K8:27)
	
	If (OB Get:C1224($toolsetSpec;"_visible";Is boolean:K8:9))
		
		C_TEXT:C284($toolsetForm)
		
		$toolsetForm:=OB Get:C1224($toolsetSpec;"Form";Is text:K8:3)
		
		C_OBJECT:C1216($toolsetSize)
		$toolsetSize:=OB Get:C1224($toolsetSpec;"_form_size";Is object:K8:27)
		
		C_LONGINT:C283($toolsetWidth)
		$toolsetWidth:=SizeObj_GetWidth ($toolsetSize)
		
		If (($curLeft+$toolsetWidth)>$containerWidth)
			$curTop:=$curTop+$masterToolsetHeight
			$curLeft:=0
		End if 
		
		C_OBJECT:C1216($objRect)
		$objRect:=RectObj_New ($curLeft;$curTop;$toolsetWidth;$masterToolsetHeight)
		
		FormObj_SetRect ($objectName;$objRect)
		
		OBJECT SET VISIBLE:C603(*;$objectName;True:C214)
		
		$curLeft:=$curLeft+$toolsetWidth+0
		
	End if 
	
End for 

If ($toolsetCount>0)
	$toolbarHeight:=$curTop+$masterToolsetHeight
End if 

$0:=$toolbarHeight
