//%attributes = {}
C_OBJECT:C1216($1;$config)
C_OBJECT:C1216($2;$commands)
C_OBJECT:C1216($3;$env)
C_TEXT:C284($0;$menuRef)

$config:=$1
$commands:=$2
$env:=$3

$menuRef:=Create menu:C408

C_LONGINT:C283($menuItemCount)
$menuItemCount:=0

C_COLLECTION:C1488($items)
$items:=Choose:C955($config.items#Null:C1517;$config.items;New collection:C1472)

C_OBJECT:C1216($itemSpec)

C_LONGINT:C283($idx)
For ($idx;0;$items.length-1)
	
	$itemSpec:=$items[$idx]
	
	Case of 
		: ($itemSpec.title#"-")
			
			C_TEXT:C284($commandID)
			$commandID:=$itemSpec.command
			
			C_OBJECT:C1216($command)
			$command:=$commands[$commandID]
			
			C_OBJECT:C1216($cmdStatus)
			$cmdStatus:=CommandNG_Status ($commandID;$command;$env)
			
			C_COLLECTION:C1488($subItems)
			$subItems:=Choose:C955($itemSpec.items#Null:C1517;$itemSpec.items;New collection:C1472)
			
			If ($cmdStatus.visible)
				
				C_TEXT:C284($itemTitle)
				$itemTitle:=Choose:C955($cmdStatus.title#Null:C1517;String:C10($cmdStatus.title);$itemSpec.title)
				
				Case of 
					: ($subItems.length>0)
						
						C_TEXT:C284($subMenu)
						$subMenu:=CommandNG_BuildMenu ($itemSpec;$commands;$env)
						
						$menuItemCount:=$menuItemCount+1
						APPEND MENU ITEM:C411($menuRef;$itemTitle;$subMenu;0;*)
						RELEASE MENU:C978($subMenu)
						
						SET MENU ITEM PARAMETER:C1004($menuRef;$menuItemCount;$commandID)
						If (Not:C34($cmdStatus.enabled))
							DISABLE MENU ITEM:C150($menuRef;$menuItemCount)
						End if 
						If ($cmdStatus.checked)
							SET MENU ITEM MARK:C208($menuRef;$menuItemCount;Char:C90(18))
						End if 
						
					Else 
						
						$menuItemCount:=$menuItemCount+1
						APPEND MENU ITEM:C411($menuRef;$itemTitle;"";0;*)
						
						SET MENU ITEM PARAMETER:C1004($menuRef;$menuItemCount;$commandID)
						If (Not:C34($cmdStatus.enabled))
							DISABLE MENU ITEM:C150($menuRef;$menuItemCount)
						End if 
						If ($cmdStatus.checked)
							SET MENU ITEM MARK:C208($menuRef;$menuItemCount;Char:C90(18))
						End if 
						
				End case 
				
			End if 
			
		Else 
			
			$menuItemCount:=$menuItemCount+1
			APPEND MENU ITEM:C411($menuRef;"(-";"";0)
			SET MENU ITEM PARAMETER:C1004($menuRef;$menuItemCount;"-")
			
	End case 
	
End for 

$0:=$menuRef
