//%attributes = {"shared":true}
C_OBJECT:C1216($0;$errInfo)  // @param: The Q2Pix error info for the current process.

  // @desc: Return the Q2Pix error info for the current process.

  // @doc: Return the Q2Pix error info for the current process.
  //
  // The error info is returned in ``errInfo``, a 4D object that contains the following properties:
  //
  // .. include:: /_shared/ImgErr_Info.rsti
  //
  // .. note:: This method is a wrapper for the :cc4d:xmethod:`ImgErr_GetInfo_JSN` plug-in method.
  //

C_TEXT:C284($errInfoJSON)
$errInfoJSON:=ImgErr_GetInfo_JSN:P11667:146 
If ($errInfoJSON#"")
	JSON_Parse (->$errInfoJSON;->$errInfo)
End if 

$0:=$errInfo

