//%attributes = {"shared":true}
C_TEXT:C284($1;$formatID)  // @param: The image format identifier.
C_TEXT:C284($0;$formatName)  // @param: The image format name.

  // @desc: Return the image format's name.

  // @doc: Return the image format's name.
  // 
  // Parameter ``formatID`` is the identifier of the image format. If ``formatID``
  // is not a valid image format identifier or empty, an empty string is returned.
  //

ASSERT:C1129(Count parameters:C259=1)

$formatID:=$1
$formatName:=""

C_OBJECT:C1216($formatInfo)
$formatInfo:=ImgFormat_GetInfo ($formatID)

$formatName:=OB Get:C1224($formatInfo;"Name";Is text:K8:3)

$0:=$formatName
