//%attributes = {"shared":true}
C_OBJECT:C1216($1;$pointObj)  // @param: The ``PointObj`` object.
C_REAL:C285($0;$x)  // @param: The X coordinate of ``pointObj``.

  // @desc: Return the X coordinate of a PointObj object.

  // @doc: Return the X coordinate of a ``PointObj`` object.
  //
  // The ``PointObj`` object is passed in the ``pointObj`` parameter.
  //
  // The X coordinate of ``pointObj`` is returned in ``x``.
  //

ASSERT:C1129(Count parameters:C259=1)

$pointObj:=$1
$x:=0

ASSERT:C1129(OB Is defined:C1231($pointObj;"X"))
ASSERT:C1129(OB Is defined:C1231($pointObj;"Y"))

$x:=OB Get:C1224($pointObj;"X";Is real:K8:4)

$0:=$x
