//%attributes = {"shared":true}
C_REAL:C285($1; $width)  // @param: The object's width.
C_REAL:C285($2; $height)  // @param: The object's height.
C_OBJECT:C1216($0; $sizeObj)  // @param: The ``SizeObj`` object.

// @desc: Make a SizeObj object.

// @doc: Make a ``SizeObj`` object.
//
// The width and height of the ``SizeObj`` object are passed in the ``width`` and ``height``
// parameters respectively.
//
// The ``SizeObj`` object is returned in ``sizeObj``.
//

ASSERT:C1129(Count parameters:C259=2)

$width:=$1
$height:=$2

$sizeObj:=New object:C1471()
OB SET:C1220($sizeObj; "Width"; $width; "Height"; $height)

$0:=$sizeObj

