//%attributes = {"invisible":true}
C_TEXT:C284($1; $path)
C_POINTER:C301($2; $itemsArrayPtr)
C_BOOLEAN:C305($3; $incudeFiles)
C_BOOLEAN:C305($4; $includeDirs)
C_BOOLEAN:C305($5; $includeHidden)
C_BOOLEAN:C305($6; $recursive)
C_TEXT:C284($7; $nameFilter)
C_BOOLEAN:C305($0; $success)

$path:=$1
$itemsArrayPtr:=$2
$incudeFiles:=$3
$includeDirs:=$4
$includeHidden:=$5
$recursive:=$6
If (Count parameters:C259>6)
	$nameFilter:=$7
Else 
	$nameFilter:=""
End if 
$success:=False:C215

Array_Clear($itemsArrayPtr)

ARRAY TEXT:C222($itemsArray; 0)

If (FSPath_IsDir($path))
	
	C_TEXT:C284($systemPath)
	$systemPath:=Convert path POSIX to system:C1107($path)
	
	C_TEXT:C284($filterPattern)
	If ($nameFilter#"")
		$filterPattern:=RE_FromGlob($nameFilter)
	End if 
	
	ARRAY TEXT:C222($filePaths; 0)
	ARRAY TEXT:C222($dirPaths; 0)
	
	If ($incudeFiles)
		
		If ($recursive)
			DOCUMENT LIST:C474($systemPath; $filePaths; Absolute path:K24:14+Posix path:K24:15+Recursive parsing:K24:13)
		Else 
			DOCUMENT LIST:C474($systemPath; $filePaths; Absolute path:K24:14+Posix path:K24:15)
		End if 
		
		C_LONGINT:C283($idx)
		
		For ($idx; 1; Size of array:C274($filePaths))
			
			C_BOOLEAN:C305($includeItem)
			$includeItem:=True:C214
			If (($includeHidden=False:C215) & FSPath_IsHidden($filePaths{$idx}))
				$includeItem:=False:C215
			End if 
			
			If ($includeItem & ($filterPattern#""))
				C_TEXT:C284($name)
				$name:=FSPath_GetName($filePaths{$idx})
				$includeItem:=RE_Match($filterPattern; $name)
			End if 
			
			If ($includeItem)
				APPEND TO ARRAY:C911($itemsArrayPtr->; $filePaths{$idx})
			End if 
			
		End for 
		
	End if 
	
	If ($includeDirs)
		
		If ($recursive)
			FSPath_RecursiveFolderList($path; ->$dirPaths)
		Else 
			FOLDER LIST:C473($systemPath; $dirPaths)
			For ($idx; 1; Size of array:C274($dirPaths))
				$dirPaths{$idx}:=FSPath_Append($path; $dirPaths{$idx})
			End for 
		End if 
		
		For ($idx; 1; Size of array:C274($dirPaths))
			
			C_BOOLEAN:C305($includeItem)
			$includeItem:=True:C214
			If (($includeHidden=False:C215) & FSPath_IsHidden($dirPaths{$idx}))
				$includeItem:=False:C215
			End if 
			
			If ($includeItem & ($filterPattern#""))
				C_TEXT:C284($name)
				$name:=FSPath_GetName($dirPaths{$idx})
				$includeItem:=RE_Match($filterPattern; $name)
			End if 
			
			If ($includeItem)
				APPEND TO ARRAY:C911($itemsArrayPtr->; $dirPaths{$idx})
			End if 
			
		End for 
		
	End if 
	
	SORT ARRAY:C229($itemsArrayPtr->)
	
	$success:=True:C214
	
End if 

$0:=$success
