//%attributes = {"shared":true}
C_OBJECT:C1216($1; $fsRef)
C_POINTER:C301($2; $modificationDatePtr)
C_POINTER:C301($3; $modificationTimePtr)
C_BOOLEAN:C305($0; $success)

$fsRef:=$1
$modificationDatePtr:=$2
$modificationTimePtr:=$3

ASSERT:C1129(Type:C295($modificationDatePtr->)=Is date:K8:7)
ASSERT:C1129(Type:C295($modificationTimePtr->)=Is time:K8:8)

$modificationDatePtr->:=!00-00-00!
$modificationTimePtr->:=?00:00:00?

If (FSRef_Exists($fsRef) & FSRef_IsFile($fsRef))
	
	C_TEXT:C284($posixPath)
	$posixPath:=OB Get:C1224($fsRef; "path"; Is text:K8:3)
	
	C_TEXT:C284($systemPath)
	$systemPath:=Convert path POSIX to system:C1107($posixPath)
	
	C_BOOLEAN:C305($locked; $invisible)
	C_DATE:C307($creationDate; $modificationDate)
	C_TIME:C306($creationTime; $modificationTime)
	
	GET DOCUMENT PROPERTIES:C477($systemPath; \
		$locked; $invisible; \
		$creationDate; $creationTime; \
		$modificationDate; $modificationTime)
	
	$modificationDatePtr->:=$modificationDate
	$modificationTimePtr->:=$modificationTime
	
End if 

$0:=$success
