//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$xmpDataRef)

$context:=$1
$xmpDataRef:=$2

ASSERT:C1129(OB Is defined:C1231($context))

If ($xmpDataRef#"")
	
	$xmpDataRef:=ImgObj_Retain:P11667:134 ($xmpDataRef)  // Retain so that caller can release
	
	  // Clear subform and release existing data
	Editor_Clear ($context)
	
	OB SET:C1220($context;"xmp_edit_data";$xmpDataRef)
	
	ARRAY TEXT:C222($rootProps;0)
	
	XMPData_GetPropertyNames:P11667:80 ($xmpDataRef;"";$rootProps)
	
	C_OBJECT:C1216($namespaces)
	
	C_LONGINT:C283($idx)
	
	For ($idx;1;Size of array:C274($rootProps))
		C_TEXT:C284($prefix)
		$prefix:=XMPProp_GetNamePrefix ($rootProps{$idx})
		If ($prefix#"")
			ARRAY TEXT:C222($nsProps;0)
			If (OB Is defined:C1231($namespaces;$prefix))
				OB GET ARRAY:C1229($namespaces;$prefix;$nsProps)
			End if 
			APPEND TO ARRAY:C911($nsProps;$rootProps{$idx})
			OB SET ARRAY:C1227($namespaces;$prefix;$nsProps)
		End if 
	End for 
	
	ARRAY TEXT:C222($nsPrefixes;0)
	OB GET PROPERTY NAMES:C1232($namespaces;$nsPrefixes)
	
	C_LONGINT:C283($nsCount)
	$nsCount:=Size of array:C274($nsPrefixes)
	
	ARRAY TEXT:C222($nsNames;$nsCount)
	For ($idx;1;$nsCount)
		
		C_TEXT:C284($prefix;$name)
		$prefix:=$nsPrefixes{$idx}
		$name:=Lib_GetNSNameWithPrefix ($prefix)
		
		$nsNames{$idx}:=$name
		
	End for 
	
	SORT ARRAY:C229($nsNames;$nsPrefixes)
	
	C_POINTER:C301($navListPtr)
	$navListPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"ns_nav_list")
	
	$navListPtr->:=New list:C375
	
	For ($idx;1;$nsCount)
		
		APPEND TO LIST:C376($navListPtr->;$nsNames{$idx};$idx)
		SET LIST ITEM PARAMETER:C986($navListPtr->;$idx;"xmp_ns_prefix";$nsPrefixes{$idx})
		
	End for 
	
	SELECT LIST ITEMS BY POSITION:C381($navListPtr->;0)
	
	OBJECT SET SUBFORM:C1138(*;"xmp_editor_pane";"XMPEditorPaneEmpty")
	
Else 
	
	  // Clear subform and release existing data
	Editor_Clear ($context)
	
End if 
