//%attributes = {"invisible":true}
C_OBJECT:C1216($1; $context)
$context:=$1

ASSERT:C1129(OB Is defined:C1231($context))

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($context; "xmp_edit_data"; Is text:K8:3)

C_POINTER:C301($navListPtr)
$navListPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "ns_nav_list")

C_LONGINT:C283($selectedItemIdx)
$selectedItemIdx:=Selected list items:C379($navListPtr->)

If ($selectedItemIdx>0)
	
	C_TEXT:C284($prefix)
	GET LIST ITEM PARAMETER:C985($navListPtr->; $selectedItemIdx; "xmp_ns_prefix"; $prefix)
	
	C_OBJECT:C1216($paneContext)
	$paneContext:=New object:C1471()
	
	OB SET:C1220($paneContext; "xmp_ns_prefix"; $prefix)
	OB SET:C1220($paneContext; "xmp_edit_data"; $xmpDataRef)
	OB SET:C1220($paneContext; "EditProps"; OB Get:C1224($context; "EditProps"; Is text:K8:3))
	
	If (OB Is defined:C1231($context; "edit_prop"))
		OB SET:C1220($paneContext; "edit_prop"; OB Get:C1224($context; "edit_prop"; Is text:K8:3))
		OB REMOVE:C1226($context; "edit_prop")
	End if 
	
	OB SET:C1220($context; "_pane"; $paneContext)
	
	OBJECT SET VISIBLE:C603(*; "xmp_editor_pane"; True:C214)
	OBJECT SET SUBFORM:C1138(*; "xmp_editor_pane"; "XMPEditorPane")
	OBJECT SET SCROLLBAR:C843(*; "xmp_editor_pane"; False:C215; True:C214)
	OBJECT SET BORDER STYLE:C1262(*; "xmp_editor_pane"; Border System:K42:33)
	
	C_OBJECT:C1216($nsInfo)
	$nsInfo:=OB Get:C1224(<>gXMPrefixes; $prefix; Is object:K8:27)
	
	C_TEXT:C284($nsTitle; $nsDesc)
	$nsTitle:=OB Get:C1224($nsInfo; "Name"; Is text:K8:3)
	If ($nsTitle="")
		$nsTitle:=Substring:C12($prefix; 1; Length:C16($prefix)-1)
	End if 
	$nsDesc:=OB Get:C1224($nsInfo; "Desc"; Is text:K8:3)
	
	C_POINTER:C301($nsTitlePtr)
	$nsTitlePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "ns_title")
	$nsTitlePtr->:=$nsTitle
	
	C_POINTER:C301($nsDescPtr)
	$nsDescPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "ns_desc")
	$nsDescPtr->:=$nsDesc
	
Else 
	
	OB REMOVE:C1226($context; "_pane")
	
	OBJECT SET VISIBLE:C603(*; "xmp_editor_pane"; False:C215)
	OBJECT SET SUBFORM:C1138(*; "xmp_editor_pane"; "XMPEditorPaneEmpty")
	OBJECT SET SCROLLBAR:C843(*; "xmp_editor_pane"; False:C215; False:C215)
	OBJECT SET BORDER STYLE:C1262(*; "xmp_editor_pane"; Border None:K42:27)
	
	C_POINTER:C301($nsTitlePtr)
	$nsTitlePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "ns_title")
	$nsTitlePtr->:=""
	
	C_POINTER:C301($nsDescPtr)
	$nsDescPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "ns_desc")
	$nsDescPtr->:=""
	
End if 

