//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$registry)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$registry:=$1
$propName:=$2
$propSpec:=$3

OB SET:C1220($registry;$propName;$propSpec)

C_TEXT:C284($propType)
$propType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)

Case of 
	: ($propType="struct")
		
		If (OB Is defined:C1231($propSpec;"Contents"))
			
			C_OBJECT:C1216($contents)
			$contents:=OB Get:C1224($propSpec;"Contents";Is object:K8:27)
			
			ARRAY TEXT:C222($names;0)
			OB GET PROPERTY NAMES:C1232($contents;$names)
			
			C_LONGINT:C283($idx)
			
			For ($idx;1;Size of array:C274($names))
				
				C_TEXT:C284($aName)
				$aName:=$names{$idx}
				
				C_OBJECT:C1216($subSpec)
				$subSpec:=OB Get:C1224($contents;$aName;Is object:K8:27)
				
				  //_XMP_RegisterPropertySpec ($registry;$propName+"/"+$aName;OB Copy($subSpec))
				Lib_RegisterPropertySpec ($registry;$propName+"/"+$aName;$subSpec)
				
			End for 
			
		End if 
		
	: ($propType="Boolean")
		
		If (Not:C34(OB Is defined:C1231($propSpec;"Choices")))
			
			  // Default choices for boolean properties
			C_OBJECT:C1216($booleanChoices)
			OB SET:C1220($booleanChoices;"True";"True")
			OB SET:C1220($booleanChoices;"False";"False")
			
			OB SET:C1220($propSpec;"Choices";OB Copy:C1225($booleanChoices))
			
		End if 
		
End case 

