//%attributes = {"invisible":true}
C_TEXT:C284($1; $name)
C_OBJECT:C1216($2; $spec)

$name:=$1
$spec:=$2

//==================================================
// Build <>gXMPPropertiesFlat/<>gXMPTypeAliases

If (Position:C15(":"; $name)>0)
	// Property spec
	
	// Set default choices for boolean properties
	C_TEXT:C284($aType)
	$aType:=OB Get:C1224($spec; "Type"; Is text:K8:3)
	If ($aType="Boolean")
		If (Not:C34(OB Is defined:C1231($spec; "Choices")))
			
			// Default choices for boolean properties
			C_OBJECT:C1216($booleanChoices)
			OB SET:C1220($booleanChoices; "True"; "True")
			OB SET:C1220($booleanChoices; "False"; "False")
			
			OB SET:C1220($spec; "Choices"; OB Copy:C1225($booleanChoices))
			
		End if 
	End if 
	
	Lib_RegisterPropertySpec(<>gXMPPropertiesFlat; $name; OB Copy:C1225($spec))
Else 
	// Typealias spec
	OB SET:C1220(<>gXMPTypeAliases; $name; OB Copy:C1225($spec))
End if 

//==================================================
// Build <>gXMPPropertiesByPrefix/<>gXMPExtPropertiesByPrefix

C_TEXT:C284($aPrefix)

$aPrefix:=XMPProp_GetNamePrefix($name)
If ($aPrefix#"")
	
	C_OBJECT:C1216($prefixProps)
	
	If (OB Is defined:C1231(<>gXMPPropertiesByPrefix; $aPrefix))
		$prefixProps:=OB Get:C1224(<>gXMPPropertiesByPrefix; $aPrefix; Is object:K8:27)
		OB SET:C1220($prefixProps; $name; $spec)
	Else 
		$prefixProps:=New object:C1471()
		OB SET:C1220($prefixProps; $name; $spec)
		OB SET:C1220(<>gXMPPropertiesByPrefix; $aPrefix; OB Copy:C1225($prefixProps))
	End if 
	
	If (OB Get:C1224($spec; "External"; Is boolean:K8:9)=True:C214)
		
		If (OB Is defined:C1231(<>gXMPExtPropertiesByPrefix; $aPrefix))
			$prefixProps:=OB Get:C1224(<>gXMPExtPropertiesByPrefix; $aPrefix; Is object:K8:27)
			OB SET:C1220($prefixProps; $name; $spec)
		Else 
			$prefixProps:=New object:C1471()
			OB SET:C1220($prefixProps; $name; $spec)
			OB SET:C1220(<>gXMPExtPropertiesByPrefix; $aPrefix; OB Copy:C1225($prefixProps))
		End if 
		
	End if 
	
End if 


