//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

ASSERT:C1129(OB Is defined:C1231($paneContext))
ASSERT:C1129(OB Is defined:C1231($propSpec))

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($paneContext;"xmp_edit_data";Is text:K8:3)

C_LONGINT:C283($controlType)
$controlType:=OBJECT Get type:C1300(*;$propName)

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName)

C_TEXT:C284($propValue)

Case of 
	: ($controlType=Object type text input:K79:4)
		
		$propValue:=$controlPtr->
		If ($propValue#"")
			XMPData_SetSimplePropertyValue:P11667:85 ($xmpDataRef;$propName;$propValue)
		Else 
			XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)
		End if 
		
	: ($controlType=Object type popup dropdown list:K79:13)
		
		Case of 
			: (OB Get type:C1230($propSpec;"Choices")=Is object:K8:27)
				
				ARRAY TEXT:C222($choiceValues;0)
				ARRAY TEXT:C222($choiceKeys;0)
				Spec_GetChoices ($propSpec;->$choiceValues;->$choiceKeys)
				
				C_LONGINT:C283($choiceIdx)
				$choiceIdx:=$controlPtr->
				
				If ($choiceIdx>0)
					If ($choiceIdx<=Size of array:C274($choiceKeys))
						$propValue:=$choiceKeys{$choiceIdx}
						XMPData_SetSimplePropertyValue:P11667:85 ($xmpDataRef;$propName;$propValue)
					Else 
						  // (None) selected, means remove property
						XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)
					End if 
					
				End if 
				
			: (OB Get type:C1230($propSpec;"Choices")=Object array:K8:28)
				
				ARRAY TEXT:C222($choiceValues;0)
				Spec_GetChoices ($propSpec;->$choiceValues)
				
				C_LONGINT:C283($choiceIdx)
				$choiceIdx:=$controlPtr->
				
				If ($choiceIdx>0)
					If ($choiceIdx<=Size of array:C274($choiceValues))
						$propValue:=$choiceValues{$choiceIdx}
						XMPData_SetSimplePropertyValue:P11667:85 ($xmpDataRef;$propName;$propValue)
					Else 
						  // (None) selected, means remove property
						XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)
					End if 
					
				End if 
				
		End case 
		
	: ($controlType=Object type combobox:K79:12)
		
		$propValue:=$controlPtr->{0}
		If ($propValue#"")
			XMPData_SetSimplePropertyValue:P11667:85 ($xmpDataRef;$propName;$propValue)
		Else 
			XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)
		End if 
		
End case 
