//%attributes = {}
C_TEXT:C284($1; $message)
C_OBJECT:C1216($2; $args)

$message:=""
If (Count parameters:C259>0)
	$message:=$1
End if 
If (Count parameters:C259>1)
	$args:=$2
End if 

Case of 
	: ($message="open") | ($message="add") | ($message="")
		
		C_LONGINT:C283($existingProcess)
		$existingProcess:=Process number:C372("$ImageMerger")
		
		If ($existingProcess#0)
			
			BRING TO FRONT:C326($existingProcess)
			
			C_OBJECT:C1216(pImageMergerArgs)
			pImageMergerArgs:=$args
			
			OB SET:C1220(pImageMergerArgs; "_message"; $message)
			
			SET PROCESS VARIABLE:C370($existingProcess; pImageMergerArgs; pImageMergerArgs)
			
			POST OUTSIDE CALL:C329($existingProcess)
			
		Else 
			
			OB SET:C1220($args; "_message"; $message)
			
			C_LONGINT:C283($newProcess)
			$newProcess:=New process:C317(Current method name:C684; 1024*1024; "$ImageMerger"; "_run"; $args)
			
		End if 
		
	: ($message="_run")
		
		SET MENU BAR:C67(1; *)
		
		C_OBJECT:C1216(pImageMergerArgs)
		pImageMergerArgs:=$args
		
		C_LONGINT:C283($window)
		$window:=Open form window:C675("ImageMerger"; Plain form window:K39:10; *)
		DIALOG:C40("ImageMerger")
		CLOSE WINDOW:C154($window)
		
	: ($message="_add")
		
		C_POINTER:C301($srcThumbPtr; $srcNamePtr; $srcCountPtr; $srcKindPtr; $srcPathPtr)
		$srcThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_thumb")
		$srcNamePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_name")
		$srcCountPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_count")
		$srcKindPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_kind")
		$srcPathPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_path")
		
		ARRAY TEXT:C222($imagePaths; 0)
		OB GET ARRAY:C1229($args; "ImagePaths"; $imagePaths)
		
		//SORT ARRAY($imagePaths)
		
		C_LONGINT:C283($dropPos)
		$dropPos:=OB Get:C1224($args; "DropPos"; Is longint:K8:6)
		If ($dropPos<=0)
			$dropPos:=Size of array:C274($srcPathPtr->)+1
		End if 
		
		C_LONGINT:C283($imageCount)
		$imageCount:=Size of array:C274($imagePaths)
		
		If ($imageCount>0)
			
			C_LONGINT:C283(_pMergerProgress)
			_pMergerProgress:=Progress New
			Progress SET PROGRESS(_pMergerProgress; -1)
			Progress SET TITLE(_pMergerProgress; "Reading images...")
			Progress SET BUTTON TITLE(_pMergerProgress; "Stop")
			Progress SET BUTTON ENABLED(_pMergerProgress; False:C215)
			Progress SET WINDOW VISIBLE(True:C214; -1; -1; True:C214)
			
			C_LONGINT:C283($idx)
			For ($idx; 1; $imageCount)
				
				C_TEXT:C284($aPath)
				$aPath:=$imagePaths{$idx}
				
				If (Find in array:C230($srcPathPtr->; $aPath)<=0)
					
					C_TEXT:C284($imgDocRef)
					$imgDocRef:=ImgDoc_CreateWithFile($aPath)
					If ($imgDocRef#"")
						
						C_OBJECT:C1216($aFileRef)
						$aFileRef:=FSRef_InitWithPOSIXPath($aPath)
						
						C_PICTURE:C286($aThumb)
						C_TEXT:C284($aName; $aKind; $aFormat)
						C_LONGINT:C283($aCount)
						
						C_OBJECT:C1216($thumbOptions)
						OB SET:C1220($thumbOptions; "MaxPixelSize"; SizeObj_New(60; 60))
						$aThumb:=ImgFrame_CreateThumbPict($imgDocRef; 1; $thumbOptions)
						$aName:=FSRef_GetName($aFileRef)
						$aCount:=ImgDoc_GetFrameCount:P11667:11($imgDocRef)
						$aFormat:=ImgDoc_GetFormat:P11667:9($imgDocRef)
						$aKind:=OB Get:C1224(ImgFormat_GetInfo($aFormat); "Name"; Is text:K8:3)
						
						INSERT IN ARRAY:C227($srcThumbPtr->; $dropPos)
						INSERT IN ARRAY:C227($srcNamePtr->; $dropPos)
						INSERT IN ARRAY:C227($srcCountPtr->; $dropPos)
						INSERT IN ARRAY:C227($srcKindPtr->; $dropPos)
						INSERT IN ARRAY:C227($srcPathPtr->; $dropPos)
						
						$srcThumbPtr->{$dropPos}:=$aThumb
						$srcNamePtr->{$dropPos}:=$aName
						$srcCountPtr->{$dropPos}:=$aCount
						$srcKindPtr->{$dropPos}:=$aKind
						$srcPathPtr->{$dropPos}:=$aPath
						
						$dropPos:=$dropPos+1
						
						ImgObj_Release:P11667:133($imgDocRef)
					End if 
					
				End if 
				
				C_REAL:C285($progress)
				$progress:=$idx/$imageCount
				
				Progress SET PROGRESS(_pMergerProgress; $progress)
				
			End for 
			
			Progress QUIT(_pMergerProgress)
			_pMergerProgress:=0
			
		End if 
		
		OBJECT SET ENABLED:C1123(*; "merge"; Size of array:C274($srcPathPtr->)>0)
		
	: ($message="remove")
		
		C_POINTER:C301($srcFilesPtr)
		$srcFilesPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_files")
		
		C_LONGINT:C283($srcFileCount)
		$srcFileCount:=Size of array:C274($srcFilesPtr->)
		
		C_LONGINT:C283($idx)
		For ($idx; $srcFileCount; 1; -1)
			If ($srcFilesPtr->{$idx})
				LISTBOX DELETE ROWS:C914(*; "src_files"; $idx)
			End if 
		End for 
		
		If (Size of array:C274($srcFilesPtr->)>0)
			OBJECT SET ENABLED:C1123(*; "merge"; True:C214)
		Else 
			OBJECT SET ENABLED:C1123(*; "merge"; False:C215)
		End if 
		
End case 
