Class extends Part

Class constructor($name : Text; $spec : Object; $style : Object; $userActions : Object)
	
	Super:C1705($name; "mn_"; $spec; $style)
	
	This:C1470.title:=Choose:C955($spec.title#Null:C1517; $spec.title; This:C1470.name)
	
	This:C1470.items:=New collection:C1472()
	
	var $itemSpec : Variant
	For each ($itemSpec; This:C1470.spec["items"])
		
		var $menuItem : cs:C1710.MenuItem
		$menuItem:=cs:C1710.MenuItem.new($itemSpec; $userActions)
		
		If ($menuItem.validate())
			This:C1470.items.push($menuItem)
		End if 
		
	End for each 
	
	
Function validate()->$valid : Boolean
	
	$valid:=(This:C1470.items.length>0)
	
	
Function getActions()->$actions : Collection
	
	$actions:=New collection:C1472()
	
	var $menuItem : cs:C1710.ActionPart
	For each ($menuItem; This:C1470.items)
		
		var $itemActions : Collection
		$itemActions:=$menuItem.getActions()
		
		$actions:=$actions.combine($itemActions)
		
	End for each 
	