Class constructor($width : Real; $height : Real)
	
	This:C1470.width:=$width
	This:C1470.height:=$height
	
	
Function calcFitScale($other : cs:C1710.Size)->$scale : Real
	
	If ($other.width#0) & ($other.height#0)
		
		var $scaleH; $scaleV; $bestScale : Real
		$bestScale:=1
		$scaleH:=This:C1470.width/$other.width
		$scaleV:=This:C1470.height/$other.height
		
		If ($scaleH<$scaleV)
			$bestScale:=$scaleH
		Else 
			$bestScale:=$scaleV
		End if 
		
		$scale:=$bestScale
		
	Else 
		$scale:=0
	End if 
	
Function calcFillScale($other : cs:C1710.Size)->$scale : Real
	
	If ($other.width#0) & ($other.height#0)
		
		var $scaleH; $scaleV; $bestScale : Real
		$bestScale:=1
		$scaleH:=This:C1470.width/$other.width
		$scaleV:=This:C1470.height/$other.height
		
		If ($scaleH<$scaleV)
			$bestScale:=$scaleV
		Else 
			$bestScale:=$scaleH
		End if 
		
		$scale:=$bestScale
		
	Else 
		$scale:=0
	End if 
	
	
Function scaledBy($scale : Real)->$scaledSize : cs:C1710.Size
	
	$scaledSize:=cs:C1710.Size.new(This:C1470.width*$scale; This:C1470.height*$scale)
	
	
Function fit($other : cs:C1710.Size; $scaleUp : Boolean)->$fitSize : cs:C1710.Size
	
	$scaleUp:=Choose:C955(Count parameters:C259>1; $scaleUp; False:C215)
	
	var $fitScale : Real
	$fitScale:=This:C1470.calcFitScale($other)
	
	If (Not:C34($scaleUp) & ($fitScale>1))
		$fitScale:=1
	End if 
	
	$fitSize:=$other.scaledBy($fitScale)
	