//%attributes = {"invisible":true}
C_TEXT:C284($1;$methodName)
C_TEXT:C284($2;$usage)
C_BOOLEAN:C305($0;$callable)

$methodName:=$1
$usage:=$2
$callable:=False:C215

If (Is compiled mode:C492(*))
	$callable:=True:C214
Else 
	
	If (Comp_MethodExists ($methodName;True:C214))  // Host database
		
		If (Not:C34(<>gQImageControllerStandalone))
			
			If (METHOD Get attribute:C1169($methodName;Attribute shared:K72:10;*))
				$callable:=True:C214
			Else 
				
				If (Not:C34(Is compiled mode:C492))
					
					ALERT:C41("ImgCtl error: project method "+String_Quoted ($methodName)+" "+String_TrimWS ($usage)+" should have its \"shared by components and host database\" attribute set.")
					TRACE:C157
					
				End if 
				
			End if 
			
		Else 
			$callable:=True:C214
		End if 
		
	Else 
		
		If (Comp_MethodExists ($methodName;False:C215))  // Component
			
			$callable:=True:C214
			
		Else 
			
			If (Not:C34(Is compiled mode:C492))
				
				ALERT:C41("ImgCtl error: project method "+String_Quoted ($methodName)+" "+String_TrimWS ($usage)+" was not found in either the Q2ImgControl component or the host database.")
				TRACE:C157
				
			End if 
			
		End if 
		
	End if 
	
End if 

$0:=$callable


