//%attributes = {}
C_OBJECT:C1216($1;$config)
C_OBJECT:C1216($2;$builtinCommands)
C_OBJECT:C1216($0;$newCommands)

$config:=$1
If (Count parameters:C259>1)
	$builtinCommands:=$2
End if 

If ($builtinCommands#Null:C1517)
	$newCommands:=$builtinCommands
Else 
	$newCommands:=New object:C1471
End if 

C_OBJECT:C1216($commands)
$commands:=Choose:C955($config.commands#Null:C1517;$config.commands;New object:C1471)

C_OBJECT:C1216($aCommand)
C_TEXT:C284($commandID)

For each ($commandID;$commands)
	
	C_TEXT:C284($methodName)
	$methodName:=$commands[$commandID].method
	
	C_OBJECT:C1216($methodCheck)
	$methodCheck:=ImgCtlNG_CheckMethod ($methodName)
	
	If ($methodCheck.exists)
		
		If ($methodCheck.shared)
			
			$newCommands[$commandID]:=$commands[$commandID]
			
		Else 
			
			If (Not:C34(Is compiled mode:C492(*)))
				ALERT:C41(\
					"[ImgCtl]\n\nProject method '"+$methodName\
					+"' which is registered for handling command '"+$commandID\
					+"' was not found in either the Q2ImgControl component or the host database.")
			End if 
			
		End if 
		
	Else 
		
		If (Not:C34(Is compiled mode:C492(*)))
			ALERT:C41(\
				"[ImgCtl]\n\nProject method '"+$methodName\
				+"' which is registered for handling command '"+$commandID\
				+"' was not found in either the Q2ImgControl component or the host database.")
		End if 
		
	End if 
	
End for each 

$0:=$newCommands
