//%attributes = {"invisible":true,"shared":true}
#DECLARE($actionName : Text; $message : Text; $context : cs:C1710.CallbackContext)->$status : Object

var $docRef; $docFormat : Text
$docRef:=$context.docRef
$docFormat:=$context.docFormat

var $frameIdx; $frameCount : Integer
$frameIdx:=$context.frameIndex
$frameCount:=$context.frameCount

$status:=New object:C1471

Case of 
	: ($actionName="img_meta")
		
		Case of 
			: ($message="status")
				
				var $xmpDataRef : Text
				If ($docFormat#"PDF")
					$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27($docRef; $frameIdx)
				Else 
					$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32($docRef)
				End if 
				
				$status.enabled:=($xmpDataRef#"")
				
				If ($xmpDataRef#"")
					ImgObj_Release:P11667:133($xmpDataRef)
				End if 
				
			: ($message="action")
				
				var $xmpDataRef : Text
				If ($docFormat#"PDF")
					$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27($docRef; $frameIdx)
				Else 
					$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32($docRef)
				End if 
				
				If ($xmpDataRef#"")
					
					var $filePath; $windowTitle : Text
					$filePath:=ImgDoc_GetFilePath($docRef)
					
					If ($filePath#"")
						var $fileObject : 4D:C1709.File
						$fileObject:=File:C1566($filePath; fk posix path:K87:1)
						$windowTitle:="XMP Metadata: "+$fileObject.name
					Else 
						$windowTitle:="XMP Metadata"
					End if 
					
					If ($docFormat#"PDF")
						If ($frameCount>1)
							$windowTitle:=$windowTitle+" / Frame "+String:C10($frameIdx)
						End if 
					End if 
					
					var $options : Object
					$options:=New object:C1471()
					$options.WindowTitle:=$windowTitle
					$options.DevMode:=(Shift down:C543 & Not:C34(Is compiled mode:C492(*)))
					
					var $success : Integer
					$success:=XMPDlog_EditData($xmpDataRef; $options)
					If ($success=1)
						
						If ($docFormat#"PDF")
							RasterFrame_SetXMPData($docRef; $frameIdx; $xmpDataRef)
						Else 
							// FIXME: PDF XMP assignment
						End if 
					End if 
					
					ImgObj_Release:P11667:133($xmpDataRef)
				End if 
				
		End case 
		
End case 
