//%attributes = {"invisible":true,"shared":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$op)
C_TEXT:C284($3;$command)
C_OBJECT:C1216($4;$args)
C_LONGINT:C283($0;$cmdStatus)

$context:=$1
$op:=$2
$command:=$3
If (Count parameters:C259>3)
	$args:=$4
End if 

$cmdStatus:=0

C_LONGINT:C283($areaRef)
$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)

C_LONGINT:C283($areaTool)
$areaTool:=ImgArea_GetTool:P11667:50 ($areaRef)

Case of 
	: ($op="status")
		
		C_TEXT:C284($docRef)
		$docRef:=ImgArea_GetDocument:P11667:41 ($areaRef)
		
		Case of 
			: ($command="img_tool_pointer")
				
				$cmdStatus:=0x0001*Num:C11($docRef#"")
				$cmdStatus:=$cmdStatus | (0x0002*Num:C11($areaTool=kImgAreaPointerTool))
				
			: ($command="img_tool_marquee")
				
				$cmdStatus:=0x0001*Num:C11($docRef#"")
				$cmdStatus:=$cmdStatus | (0x0002*Num:C11($areaTool=kImgAreaMarqueeTool))
				
			: ($command="img_tool_zoom")
				
				$cmdStatus:=0x0001*Num:C11($docRef#"")
				$cmdStatus:=$cmdStatus | (0x0002*Num:C11($areaTool=kImgAreaZoomTool))
				
			: ($command="img_tool_hand")
				
				$cmdStatus:=0x0001*Num:C11($docRef#"")
				$cmdStatus:=$cmdStatus | (0x0002*Num:C11($areaTool=kImgAreaHandTool))
				
		End case 
		
		If ($docRef#"")
			ImgObj_Release:P11667:133 ($docRef)
		End if 
		
	: ($op="run")
		
		Case of 
			: ($command="img_tool_pointer")
				
				ImgArea_SetTool:P11667:51 ($areaRef;kImgAreaPointerTool)
				
			: ($command="img_tool_marquee")
				
				ImgArea_SetTool:P11667:51 ($areaRef;kImgAreaMarqueeTool)
				
			: ($command="img_tool_zoom")
				
				ImgArea_SetTool:P11667:51 ($areaRef;kImgAreaZoomTool)
				
			: ($command="img_tool_hand")
				
				ImgArea_SetTool:P11667:51 ($areaRef;kImgAreaHandTool)
				
		End case 
		
	: ($op="update")
		
		C_TEXT:C284($docRef)
		$docRef:=ImgArea_GetDocument:P11667:41 ($areaRef)
		If ($docRef#"")
			
			OBJECT SET ENABLED:C1123(*;"pointer_tool";True:C214)
			OBJECT SET ENABLED:C1123(*;"marquee_tool";True:C214)
			OBJECT SET ENABLED:C1123(*;"hand_tool";True:C214)
			
			C_LONGINT:C283($tool)
			$tool:=ImgArea_GetTool:P11667:50 ($areaRef)
			
			C_POINTER:C301($toolObjPtr)
			Case of 
				: ($tool=kImgAreaPointerTool)
					
					$toolObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"pointer_tool")
					
				: ($tool=kImgAreaMarqueeTool)
					
					$toolObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"marquee_tool")
					
				: ($tool=kImgAreaHandTool)
					
					$toolObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"hand_tool")
					
			End case 
			
			If (Not:C34(Is nil pointer:C315($toolObjPtr)))
				$toolObjPtr->:=1
			End if 
			
			ImgObj_Release:P11667:133 ($docRef)
			
		Else 
			
			OBJECT SET ENABLED:C1123(*;"pointer_tool";False:C215)
			OBJECT SET ENABLED:C1123(*;"marquee_tool";False:C215)
			OBJECT SET ENABLED:C1123(*;"hand_tool";False:C215)
			
		End if 
		
End case 

$0:=$cmdStatus
