//%attributes = {"invisible":true,"shared":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$op)
C_TEXT:C284($3;$command)
C_OBJECT:C1216($4;$args)
C_LONGINT:C283($0;$cmdStatus)

$context:=$1
$op:=$2
$command:=$3
If (Count parameters:C259>3)
	$args:=$4
End if 

$cmdStatus:=0

C_LONGINT:C283($areaRef)
$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)

C_TEXT:C284($docRef)
$docRef:=ImgArea_GetDocument:P11667:41 ($areaRef)
If ($docRef#"")
	
	C_OBJECT:C1216($zoomFactorRange)
	ImgArea_GetProperty ($areaRef;"ZoomFactorRange";->$zoomFactorRange)
	
	C_REAL:C285($zoomFactorMin;$zoomFactorMax)
	$zoomFactorMin:=OB Get:C1224($zoomFactorRange;"Minimum";Is real:K8:4)
	$zoomFactorMax:=OB Get:C1224($zoomFactorRange;"Maximum";Is real:K8:4)
	
	C_REAL:C285($zoomToolRate)
	ImgArea_GetProperty ($areaRef;"ZoomToolRate";->$zoomToolRate)
	
	C_REAL:C285($zoomFactor)
	$zoomFactor:=ImgArea_GetZoomFactor:P11667:44 ($areaRef)
	
	C_LONGINT:C283($autoZoom)
	$autoZoom:=ImgArea_GetAutoZoom:P11667:54 ($areaRef)
	
	Case of 
		: ($op="status")
			
			Case of 
				: ($command="img_zoom_in")
					
					$cmdStatus:=0x0001*Num:C11($zoomFactor<$zoomFactorMax)
					
				: ($command="img_zoom_out")
					
					$cmdStatus:=0x0001*Num:C11($zoomFactor>$zoomFactorMin)
					
				: ($command="img_zoom_100")
					
					$cmdStatus:=0x0001
					
				: ($command="img_zoom_fit")
					
					$cmdStatus:=0x0001
					If ($autoZoom#0)
						$cmdStatus:=$cmdStatus | 0x0002
					End if 
					
				: ($command="img_zoom_percent")
					
					$cmdStatus:=0x0001
					
			End case 
			
		: ($op="run")
			
			Case of 
				: ($command="img_zoom_in")
					
					$zoomFactor:=$zoomFactor*$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax ($zoomFactor;$zoomFactorMin;$zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;$zoomFactor)
					
				: ($command="img_zoom_out")
					
					$zoomFactor:=$zoomFactor/$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax ($zoomFactor;$zoomFactorMin;$zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;$zoomFactor)
					
				: ($command="img_zoom_100")
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;1)
					
				: ($command="img_zoom_fit")
					
					ImgArea_SetAutoZoom:P11667:55 ($areaRef;kImgAreaAutoZoomToFit | kImgAreaAutoZoomStretch | kImgAreaAutoZoomSticky)
					
				: ($command="img_zoom_percent")
					
					$zoomFactor:=OB Get:C1224($args;"zoom_percent";Is real:K8:4)/100
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;$zoomFactor)
					
			End case 
			
		: ($op="update")
			
			C_REAL:C285($zoomFactor)
			$zoomFactor:=ImgArea_GetZoomFactor:P11667:44 ($areaRef)
			
			If ($zoomFactor=0)
				$zoomFactor:=1
			End if 
			
			C_POINTER:C301($zoomPercentPtr)
			$zoomPercentPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"zoom_percent")
			
			C_TEXT:C284($zoomString)
			$zoomString:=ZoomPercent_Format ($zoomFactor*100)
			
			$zoomPercentPtr->:=$zoomString+"%"
			
	End case 
	
	ImgObj_Release:P11667:133 ($docRef)
	
Else 
	
	Case of 
		: ($op="update")
			
			C_POINTER:C301($zoomPercentPtr)
			$zoomPercentPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"zoom_percent")
			$zoomPercentPtr->:=""
			
	End case 
	
End if 

$0:=$cmdStatus
