//%attributes = {}
C_OBJECT:C1216($1;$context)
C_OBJECT:C1216($2;$event)
C_LONGINT:C283($3;$popupX)
C_LONGINT:C283($4;$popupY)

$context:=$1
$event:=$2
$popupX:=$3
$popupY:=$4

C_TEXT:C284($toolControlName)
$toolControlName:=$event.objectName

C_OBJECT:C1216($tool)
$tool:=$context.formControls[$toolControlName]
If ($tool#Null:C1517)
	
	C_TEXT:C284($command;$method)
	$command:=$tool.command
	$method:=$tool.method
	
	Case of 
		: ($tool.type="button")
			
			Case of 
				: ($event.code=On Clicked:K2:4)
					
					C_COLLECTION:C1488($items)
					$items:=Choose:C955($tool.items#Null:C1517;$tool.items;New collection:C1472)
					If ($items.length>0)
						
						ImgCtlNG_HandlePopup ($context;\
							$items;\
							$context.controlStates;\
							$context.config.commands;\
							$popupX;$popupY)
						
					Else 
						
						CALL FORM:C1391(Current form window:C827;"ImgCtlCtx_HandleAction";$context;$method;$command)
						
					End if 
					
			End case 
			
		: (($tool.type="radio") | ($tool.type="check"))
			
			Case of 
				: ($event.code=On Clicked:K2:4)
					
					CALL FORM:C1391(Current form window:C827;"ImgCtlCtx_HandleAction";$context;$method;$command)
					
			End case 
			
		: ($tool.type="input")
			
			Case of 
				: ($event.code=On Getting Focus:K2:7)
					
					C_OBJECT:C1216($state)
					$state:=$context.controlStates[$command]
					
					Case of 
						: ($tool.input.valueType="integer")
							
							OBJECT SET FILTER:C235(*;$tool.controlName;"&9")
							
							Form:C1466.controlValues[$toolControlName]:=String:C10($state.value)
							
						: ($tool.input.valueType="number")
							
						: ($tool.input.valueType="percent")
							
							OBJECT SET FILTER:C235(*;$tool.controlName;"&\"0-9;.\"")
							
							Form:C1466.controlValues[$toolControlName]:=String:C10($state.value)
							
					End case 
					
					HIGHLIGHT TEXT:C210(*;$tool.controlName;0;MAXLONG:K35:2)
					
				: ($event.code=On Losing Focus:K2:8)
					
					C_OBJECT:C1216($state)
					$state:=$context.controlStates[$command]
					
					OBJECT SET FILTER:C235(*;$tool.controlName;"")
					
					Case of 
						: ($tool.input.valueType="integer")
							
							C_TEXT:C284($displayValue)
							If ($state.displayValue#Null:C1517)
								$displayValue:=String:C10($state.displayValue)
							Else 
								If ($state.value#Null:C1517)
									$displayValue:=String:C10(Int:C8(Num:C11($state.value)))
								End if 
							End if 
							
							Form:C1466.controlValues[$toolControlName]:=$displayValue
							
						: ($tool.input.valueType="number")
							
						: ($tool.input.valueType="percent")
							
							C_TEXT:C284($displayValue)
							If ($state.displayValue#Null:C1517)
								$displayValue:=String:C10($state.displayValue)
							Else 
								If ($state.value#Null:C1517)
									$displayValue:=String:C10(Num:C11($state.value))
								End if 
							End if 
							
							Form:C1466.controlValues[$toolControlName]:=$displayValue
							
					End case 
					
				: ($event.code=On Data Change:K2:15)
					
					C_OBJECT:C1216($state)
					$state:=$context.controlStates[$command]
					
					Case of 
						: ($tool.input.valueType="integer")
							
							C_LONGINT:C283($intValue)
							$intValue:=Int:C8(Num:C11(Form:C1466.controlValues[$toolControlName]))
							
							C_VARIANT:C1683($minIntValue;$maxIntValue)
							$minIntValue:=Choose:C955($state.minValue#Null:C1517;$state.minValue;$tool.input.minValue)
							$maxIntValue:=Choose:C955($state.maxValue#Null:C1517;$state.maxValue;$tool.input.maxValue)
							
							C_BOOLEAN:C305($validInt)
							$validInt:=True:C214
							
							If ($minIntValue#Null:C1517)
								If ($intValue<Num:C11($minIntValue))
									$validInt:=False:C215
								End if 
							End if 
							
							If ($validInt)
								If ($maxIntValue#Null:C1517)
									If ($intValue>Num:C11($maxIntValue))
										$validInt:=False:C215
									End if 
								End if 
							End if 
							
							If ($validInt)
								CALL FORM:C1391(Current form window:C827;\
									"ImgCtlCtx_HandleAction";$context;$method;$command;\
									New object:C1471("value";$intValue))
							Else 
								BEEP:C151()
							End if 
							
						: ($tool.input.valueType="number")
							
						: ($tool.input.valueType="percent")
							
							C_REAL:C285($percentValue)
							$percentValue:=Num:C11(Form:C1466.controlValues[$toolControlName])
							
							C_VARIANT:C1683($minPercentValue;$maxPercentValue)
							$minPercentValue:=Choose:C955($state.minValue#Null:C1517;$state.minValue;$tool.input.minValue)
							$maxPercentValue:=Choose:C955($state.maxValue#Null:C1517;$state.maxValue;$tool.input.maxValue)
							
							C_BOOLEAN:C305($validPercent)
							$validPercent:=True:C214
							
							If ($minPercentValue#Null:C1517)
								If ($percentValue<Num:C11($minPercentValue))
									$validPercent:=False:C215
								End if 
							End if 
							
							If ($validPercent)
								If ($maxPercentValue#Null:C1517)
									If ($percentValue>Num:C11($maxPercentValue))
										$validPercent:=False:C215
									End if 
								End if 
							End if 
							
							If ($validPercent)
								CALL FORM:C1391(Current form window:C827;\
									"ImgCtlCtx_HandleAction";$context;$method;$command;\
									New object:C1471("value";$percentValue))
							Else 
								BEEP:C151()
							End if 
							
							
					End case 
					
			End case 
			
	End case 
	
End if 

