//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$cmdRegistry)
C_OBJECT:C1216($2;$menuItemSpec)
C_TEXT:C284($3;$defaultHandler)

ASSERT:C1129(Count parameters:C259>=2)

$cmdRegistry:=$1
$menuItemSpec:=$2
If (Count parameters:C259>2)
	$defaultHandler:=$3
End if 

C_TEXT:C284($cmdName;$itemHandler)
$cmdName:=OB Get:C1224($menuItemSpec;"Command";Is text:K8:3)
$itemHandler:=OB Get:C1224($menuItemSpec;"Handler";Is text:K8:3)
$itemHandler:=Choose:C955($itemHandler#"";$itemHandler;$defaultHandler)
If (($itemHandler#"") & ($cmdName#""))
	Command_Register ($cmdRegistry;$cmdName;$itemHandler)
End if 

If (OB Get type:C1230($menuItemSpec;"Items")=Object array:K8:28)
	
	ARRAY OBJECT:C1221($subItemSpecs;0)
	OB GET ARRAY:C1229($menuItemSpec;"Items";$subItemSpecs)
	
	C_LONGINT:C283($idx)
	
	For ($idx;1;Size of array:C274($subItemSpecs))
		
		C_OBJECT:C1216($subSpec)
		$subSpec:=$subItemSpecs{$idx}
		
		Menubar_RegisterItemCmd ($cmdRegistry;$subSpec;$itemHandler)
		
	End for 
	
End if 
