//%attributes = {}
C_OBJECT:C1216($1;$context)
C_OBJECT:C1216($2;$thumbObj)
C_OBJECT:C1216($0;$newThumbObj)

$context:=$1
$thumbObj:=$2

C_TEXT:C284($thumbFormat)
$thumbFormat:="JPEG"

C_TEXT:C284($svgSource)
$svgSource:=$context.thumbTemplate.svgSource

C_TEXT:C284($svgRef)
$svgRef:=DOM Parse XML variable:C720($svgSource)

C_TEXT:C284($outlineElem;$pictElem;$textElem;$selectionElem)
$outlineElem:=DOM Find XML element by ID:C1010($svgRef;"outline")
$pictElem:=DOM Find XML element by ID:C1010($svgRef;"pict")
$textElem:=DOM Find XML element by ID:C1010($svgRef;"text")
$selectionElem:=DOM Find XML element by ID:C1010($svgRef;"selection")

C_OBJECT:C1216($pictSpace)
$pictSpace:=$context.thumbTemplate.pictSpace


C_LONGINT:C283($selectedFrame)
$selectedFrame:=ImgArea_GetFrameIndex:P11667:42 ($context.areaRef)

C_BOOLEAN:C305($selected)
$selected:=($thumbObj.index=$selectedFrame)

C_BLOB:C604($thumbData)

C_TEXT:C284($docRef)
$docRef:=ImgArea_GetDocument:P11667:41 ($context.areaRef)
If ($docRef#"")
	
	C_OBJECT:C1216($thumbOptions)
	$thumbOptions:=New object:C1471(\
		"Format";$thumbFormat;\
		"ApplyOrientation";True:C214;\
		"Oriented";True:C214;\
		"MaxPixelSize";New object:C1471(\
		"Width";$pictSpace.width;"Height";$pictSpace.height))
	
	$thumbData:=ImgFrame_CreateThumb ($docRef;$thumbObj.index;$thumbOptions)
	
	ImgObj_Release:P11667:133 ($docRef)
End if 

If (BLOB size:C605($thumbData)>0)
	
	C_TEXT:C284($thumbDoc)
	$thumbDoc:=ImgDoc_CreateWithBLOB (->$thumbData;New object:C1471("Format";$thumbFormat))
	
	C_OBJECT:C1216($thumbSize)
	$thumbSize:=ImgFrame_GetPointSize ($thumbDoc;1;True:C214)
	
	ImgObj_Release:P11667:133 ($thumbDoc)
	
	
	C_REAL:C285($thumbWidth;$thumbHeight)
	$thumbWidth:=SizeObj_GetWidth ($thumbSize)
	$thumbHeight:=SizeObj_GetHeight ($thumbSize)
	
	C_REAL:C285($thumbX;$thumbY)
	$thumbX:=$pictSpace.x+(($pictSpace.width-$thumbWidth)/2)
	$thumbY:=$pictSpace.y+(($pictSpace.height-$thumbHeight)/2)
	
	C_TEXT:C284($thumbData64)
	$thumbData64:=""
	
	BASE64 ENCODE:C895($thumbData;$thumbData64)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;\
		"x";$thumbX;\
		"y";$thumbY;\
		"width";$thumbWidth;\
		"height";$thumbHeight)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;"xlink:href";"data:;base64,"+$thumbData64)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;"visibility";"visible")
	DOM SET XML ATTRIBUTE:C866($outlineElem;"visibility";"hidden")
	
Else 
	DOM SET XML ATTRIBUTE:C866($pictElem;"visibility";"hidden")
	DOM SET XML ATTRIBUTE:C866($outlineElem;"visibility";"visible")
End if 

DOM SET XML ELEMENT VALUE:C868($textElem;String:C10($thumbObj.index))

DOM SET XML ATTRIBUTE:C866($selectionElem;\
"visibility";\
Choose:C955($selected;"visible";"hidden"))

  //SVGTool_SHOW_IN_VIEWER ($svgRef)

C_PICTURE:C286($pict)
$pict:=SVG_Export_to_picture ($svgRef)

SVG_CLEAR ($svgRef)

$newThumbObj:=OB Copy:C1225($thumbObj)
$newThumbObj.pict:=$pict
$newThumbObj.dirty:=False:C215
$newThumbObj.source:=$thumbData64

$0:=$newThumbObj
