//%attributes = {}
C_LONGINT:C283($1;$cellWidth)
C_LONGINT:C283($2;$cellHeight)
C_OBJECT:C1216($3;$metrics)
C_OBJECT:C1216($0;$template)

$cellWidth:=$1
$cellHeight:=$2
$metrics:=$3

C_LONGINT:C283($marginX;$marginY)
$marginX:=$metrics.sidebar.thumb.marginX
$marginY:=$metrics.sidebar.thumb.marginY

C_LONGINT:C283($pictSpaceX;$pictSpaceY)
$pictSpaceX:=$marginX
$pictSpaceY:=$marginY

C_LONGINT:C283($pictSpaceW;$pictSpaceH)
$pictSpaceW:=$cellWidth-($marginX*2)
$pictSpaceH:=$cellWidth-($marginY*2)

C_LONGINT:C283($pictSpaceRadX;$pictSpaceRadY)
$pictSpaceRadX:=$marginX*2
$pictSpaceRadY:=$marginY*2

C_TEXT:C284($imageRef;$pictSpaceElem;$textArea;$selRect)

C_TEXT:C284($svgRef)
$svgRef:=DOM Create XML Ref:C861("svg";"http://www.w3.org/2000/svg";"xmlns:xlink";"http://www.w3.org/1999/xlink")
DOM SET XML ATTRIBUTE:C866($svgRef;"width";$cellWidth;"height";$cellHeight)

C_TEXT:C284($outlineElem)
$outlineElem:=DOM Create XML element:C865($svgRef;"rect";\
"id";"outline";\
"visiblility";"visible";\
"x";$pictSpaceX;\
"y";$pictSpaceY;\
"width";$pictSpaceW;\
"height";$pictSpaceH;\
"rx";$pictSpaceRadX;"ry";$pictSpaceRadY;\
"stroke";$metrics.sidebar.thumb.strokeColor;\
"fill";$metrics.sidebar.thumb.fillColor;\
"stroke-opacity";$metrics.sidebar.thumb.strokeOpacity;\
"fill-opacity";$metrics.sidebar.thumb.fillOpacity;\
"stroke-width";$metrics.sidebar.thumb.lineWidth)

C_TEXT:C284($pictElem)
$pictElem:=DOM Create XML element:C865($svgRef;"image";\
"id";"pict";\
"visiblility";"visible";\
"x";$pictSpaceX;\
"y";$pictSpaceY;\
"width";$pictSpaceW;\
"height";$pictSpaceH;\
"xlink:href";"data:;base64,")

C_TEXT:C284($textElem)
$textElem:=DOM Create XML element:C865($svgRef;"textArea";\
"id";"text";\
"visiblility";"visible";\
"x";$marginX;\
"y";$marginY+$pictSpaceH+$marginY;\
"width";$pictSpaceW;\
"height";$cellHeight-($marginY+$pictSpaceH+$marginY);\
"font-family";$metrics.sidebar.thumb.fontFamily;\
"font-style";$metrics.sidebar.thumb.fontStyle;\
"font-size";$metrics.sidebar.thumb.fontSize;\
"text-align";$metrics.sidebar.thumb.textAlign;\
"font-weight";"normal";\
"text-decoration";"none")

C_TEXT:C284($selectionElem)
$selectionElem:=DOM Create XML element:C865($svgRef;"rect";\
"id";"selection";\
"visiblility";"visible";\
"x";$metrics.sidebar.selectedThumb.lineWidth/2;\
"y";$metrics.sidebar.selectedThumb.lineWidth/2;\
"width";$cellWidth-$metrics.sidebar.selectedThumb.lineWidth;\
"height";$cellHeight-$metrics.sidebar.selectedThumb.lineWidth;\
"rx";$metrics.sidebar.selectedThumb.lineWidth;\
"ry";$metrics.sidebar.selectedThumb.lineWidth;\
"stroke";$metrics.sidebar.selectedThumb.strokeColor;\
"fill";$metrics.sidebar.selectedThumb.fillColor;\
"stroke-opacity";$metrics.sidebar.selectedThumb.strokeOpacity;\
"fill-opacity";$metrics.sidebar.selectedThumb.fillOpacity;\
"stroke-width";$metrics.sidebar.selectedThumb.lineWidth)

  //C_BOOLEAN(<>__inspect_thumb_svg)
  //If (<>__inspect_thumb_svg)
  //SVGTool_SHOW_IN_VIEWER ($svgRef)
  //End if 

C_TEXT:C284($svgSource)
DOM EXPORT TO VAR:C863($svgRef;$svgSource)
DOM CLOSE XML:C722($svgRef)

$template:=New object:C1471()

$template.width:=$cellWidth
$template.height:=$cellHeight

$template.pictSpace:=New object:C1471()
$template.pictSpace.x:=$pictSpaceX
$template.pictSpace.y:=$pictSpaceY
$template.pictSpace.width:=$pictSpaceW
$template.pictSpace.height:=$pictSpaceH

$template.svgSource:=$svgSource

$0:=$template
