//%attributes = {}
C_OBJECT:C1216($1;$context)
C_OBJECT:C1216($2;$thumbObj)
C_OBJECT:C1216($0;$newThumbObj)

$context:=$1
$thumbObj:=$2

C_TEXT:C284($thumbFormat)
$thumbFormat:="JPEG"

C_TEXT:C284($svgSource)
$svgSource:=$context.thumbTemplate.svgSource

C_TEXT:C284($svgRef)
$svgRef:=DOM Parse XML variable:C720($svgSource)

C_TEXT:C284($outlineElem;$pictElem;$textElem;$selectionElem)
$outlineElem:=DOM Find XML element by ID:C1010($svgRef;"outline")
$pictElem:=DOM Find XML element by ID:C1010($svgRef;"pict")
$textElem:=DOM Find XML element by ID:C1010($svgRef;"text")
$selectionElem:=DOM Find XML element by ID:C1010($svgRef;"selection")

C_OBJECT:C1216($pictSpace)
$pictSpace:=$context.thumbTemplate.pictSpace


C_LONGINT:C283($selectedFrame)
$selectedFrame:=ImgArea_GetFrameIndex:P11667:42 ($context.areaRef)

C_BOOLEAN:C305($selected)
$selected:=($thumbObj.index=$selectedFrame)

C_TEXT:C284($thumbData64)
If ($thumbObj.source#Null:C1517)
	$thumbData64:=$thumbObj.source
End if 

If ($thumbData64#"")
	
	C_BLOB:C604($thumbData)
	BASE64 DECODE:C896($thumbData64;$thumbData)
	
	C_TEXT:C284($thumbDoc)
	$thumbDoc:=ImgDoc_CreateWithBLOB (->$thumbData;New object:C1471("Format";$thumbFormat))
	
	C_OBJECT:C1216($thumbSize)
	$thumbSize:=ImgFrame_GetPointSize ($thumbDoc;1;True:C214)
	
	ImgObj_Release:P11667:133 ($thumbDoc)
	
	
	C_REAL:C285($thumbWidth;$thumbHeight)
	$thumbWidth:=SizeObj_GetWidth ($thumbSize)
	$thumbHeight:=SizeObj_GetHeight ($thumbSize)
	
	C_OBJECT:C1216($thumbRect)
	$thumbRect:=Rect_FitScaledProp (\
		RectObj_New (0;0;$thumbWidth;$thumbHeight);\
		RectObj_New ($pictSpace.x;$pictSpace.y;$pictSpace.width;$pictSpace.height);\
		True:C214;True:C214)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;\
		"x";RectObj_GetX ($thumbRect);\
		"y";RectObj_GetY ($thumbRect);\
		"width";RectObj_GetWidth ($thumbRect);\
		"height";RectObj_GetHeight ($thumbRect))
	
	DOM SET XML ATTRIBUTE:C866($pictElem;"xlink:href";"data:;base64,"+$thumbData64)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;"visibility";"visible")
	DOM SET XML ATTRIBUTE:C866($outlineElem;"visibility";"hidden")
	
Else 
	DOM SET XML ATTRIBUTE:C866($pictElem;"visibility";"hidden")
	DOM SET XML ATTRIBUTE:C866($outlineElem;"visibility";"visible")
End if 

DOM SET XML ELEMENT VALUE:C868($textElem;String:C10($thumbObj.index))

DOM SET XML ATTRIBUTE:C866($selectionElem;\
"visibility";\
Choose:C955($selected;"visible";"hidden"))

  //SVGTool_SHOW_IN_VIEWER ($svgRef)

C_PICTURE:C286($pict)
$pict:=SVG_Export_to_picture ($svgRef)

SVG_CLEAR ($svgRef)

$newThumbObj:=OB Copy:C1225($thumbObj)
$newThumbObj.pict:=$pict
$newThumbObj.dirty:=True:C214

$0:=$newThumbObj
