C_POINTER:C301($formatPopupPtr)
$formatPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"format_popup")

C_POINTER:C301($genericApplyOrientationPtr)
$genericApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"generic_apply_orientation")

C_POINTER:C301($jpegQualityPtr;$jpegRecompressPtr;$jpegEmbedThumbPtr;$jpegApplyOrientationPtr)
$jpegQualityPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_quality")
$jpegRecompressPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_recompress")
$jpegEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_embed_thumb")
$jpegApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_apply_orientation")

C_POINTER:C301($tiffCodecBWPopupPtr;$tiffCodecGrayPopupPtr;$tiffCodecColorPopupPtr;\
$tiffEmbedThumbPtr;$tiffApplyOrientationPtr)
$tiffCodecBWPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_bw_popup")
$tiffCodecGrayPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_gray_popup")
$tiffCodecColorPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_color_popup")
$tiffEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_embed_thumb")
$tiffApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_apply_orientation")

C_POINTER:C301($jp2QualityPtr;$jp2RecompressPtr;$jp2EmbedThumbPtr;$jp2ApplyOrientationPtr)
$jp2QualityPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_quality")
$jp2RecompressPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_recompress")
$jp2EmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_embed_thumb")
$jp2ApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_apply_orientation")

C_POINTER:C301($psdEmbedThumbPtr;$psdApplyOrientationPtr)
$psdEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"psd_embed_thumb")
$psdApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"psd_apply_orientation")

C_LONGINT:C283($selectedIdx)
$selectedIdx:=$formatPopupPtr->

If ($selectedIdx>0)
	
	C_TEXT:C284($selectedFormat)
	$selectedFormat:=pExportFormatIDs{$selectedIdx}
	
	C_BOOLEAN:C305($accept)
	$accept:=True:C214
	
	If (pSaveMultiframe)
		
		If (($selectedFormat#"TIFF") & ($selectedFormat#"PDF"))
			
			CONFIRM:C162("This is a multi-frame image document.\n\n"\
				+"Saving to a format other than TIFF or PDF will keep only the first frame.\n\n"\
				+"Continue?";\
				"Continue")
			
			$accept:=(OK=1)
			
		End if 
		
	End if 
	
	If ($accept)
		
		C_BOOLEAN:C305($recompress;$embedThumb)
		$recompress:=($jpegRecompressPtr->=1)
		$embedThumb:=($jpegEmbedThumbPtr->=1)
		
		C_REAL:C285($quality)
		$quality:=$jpegQualityPtr->/10
		
		C_LONGINT:C283($tiffCodecBWEncoding;$tiffCodecGrayEncoding;$tiffCodecColorEncoding)
		$tiffCodecBWEncoding:=pTIFFCodecBWValues{$tiffCodecBWPopupPtr->}
		$tiffCodecGrayEncoding:=pTIFFCodecGrayValues{$tiffCodecGrayPopupPtr->}
		$tiffCodecColorEncoding:=pTIFFCodecColorValues{$tiffCodecColorPopupPtr->}
		
		pFormatOptions:=OB Copy:C1225(pFormatOptions)
		OB SET:C1220(pFormatOptions;"Format";$selectedFormat)
		OB SET:C1220(pFormatOptions;"EmbedThumbnail";$embedThumb)
		OB SET:C1220(pFormatOptions;"LossyCompressionQuality";$quality)
		OB SET:C1220(pFormatOptions;"Recompress";$recompress)
		OB SET:C1220(pFormatOptions;"TIFFMonochromeEncoding";$tiffCodecBWEncoding)
		OB SET:C1220(pFormatOptions;"TIFFGrayscaleEncoding";$tiffCodecGrayEncoding)
		OB SET:C1220(pFormatOptions;"TIFFColorEncoding";$tiffCodecColorEncoding)
		
		C_BOOLEAN:C305($applyOrientation)
		
		Case of 
			: ($selectedFormat="JPEG")
				$applyOrientation:=($jpegApplyOrientationPtr->=1)
			: ($selectedFormat="TIFF")
				$applyOrientation:=($tiffApplyOrientationPtr->=1)
			: ($selectedFormat="JPEG 2000")
				$applyOrientation:=($jp2ApplyOrientationPtr->=1)
			: ($selectedFormat="PSD")
				$applyOrientation:=($psdApplyOrientationPtr->=1)
			Else 
				$applyOrientation:=($genericApplyOrientationPtr->=1)
		End case 
		
		OB SET:C1220(pFormatOptions;"ApplyOrientation";$applyOrientation)
		
		ACCEPT:C269
		
	End if 
	
End if 
