C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Load:K2:1)
		
		  // ==================================
		  // Get pointers
		
		C_POINTER:C301($formatPopupPtr)
		$formatPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"format_popup")
		
		C_POINTER:C301($genericApplyOrientationPtr)
		$genericApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"generic_apply_orientation")
		
		C_POINTER:C301($jpegQualityPtr;$jpegRecompressPtr;$jpegEmbedThumbPtr;$jpegApplyOrientationPtr)
		$jpegQualityPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_quality")
		$jpegRecompressPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_recompress")
		$jpegEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_embed_thumb")
		$jpegApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jpeg_apply_orientation")
		
		C_POINTER:C301($tiffCodecBWPopupPtr;$tiffCodecGrayPopupPtr;$tiffCodecColorPopupPtr;\
			$tiffEmbedThumbPtr;$tiffApplyOrientationPtr)
		$tiffCodecBWPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_bw_popup")
		$tiffCodecGrayPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_gray_popup")
		$tiffCodecColorPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_codec_color_popup")
		$tiffEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_embed_thumb")
		$tiffApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"tiff_apply_orientation")
		
		C_POINTER:C301($jp2QualityPtr;$jp2RecompressPtr;$jp2EmbedThumbPtr;$jp2ApplyOrientationPtr)
		$jp2QualityPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_quality")
		$jp2RecompressPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_recompress")
		$jp2EmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_embed_thumb")
		$jp2ApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"jp2_apply_orientation")
		
		C_POINTER:C301($psdEmbedThumbPtr;$psdApplyOrientationPtr)
		$psdEmbedThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"psd_embed_thumb")
		$psdApplyOrientationPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"psd_apply_orientation")
		
		  // ==================================
		  // Setup format popup
		
		C_TEXT:C284($selectedFormat)
		If (OB Is defined:C1231(pFormatOptions;"Format"))
			$selectedFormat:=OB Get:C1224(pFormatOptions;"Format";Is text:K8:3)
		Else 
			$selectedFormat:=ImgDoc_GetFormat:P11667:9 (pSaveDoc)
		End if 
		
		C_LONGINT:C283($selectedIdx)
		$selectedIdx:=Find in array:C230(pExportFormatIDs;$selectedFormat)
		If ($selectedIdx<=0)
			$selectedIdx:=Find in array:C230(pExportFormatIDs;"TIFF")
		End if 
		If ($selectedIdx<=0)
			$selectedIdx:=Find in array:C230(pExportFormatIDs;"JPEG")
		End if 
		If ($selectedIdx<=0)
			$selectedIdx:=1
		End if 
		$selectedFormat:=pExportFormatIDs{$selectedIdx}
		
		COPY ARRAY:C226(pExportFormatNames;$formatPopupPtr->)
		$formatPopupPtr->:=$selectedIdx
		
		  // ==================================
		  // Setup TIFF popups
		
		ARRAY TEXT:C222(pTIFFCodecBWNames;0)
		ARRAY LONGINT:C221(pTIFFCodecBWValues;0)
		
		APPEND TO ARRAY:C911(pTIFFCodecBWNames;"CCITT Fax 4")
		APPEND TO ARRAY:C911(pTIFFCodecBWValues;kTIFFCompressionCCITTFax4)
		APPEND TO ARRAY:C911(pTIFFCodecBWNames;"CCITT Fax 3")
		APPEND TO ARRAY:C911(pTIFFCodecBWValues;kTIFFCompressionCCITTFax3)
		APPEND TO ARRAY:C911(pTIFFCodecBWNames;"CCITT RLE")
		APPEND TO ARRAY:C911(pTIFFCodecBWValues;kTIFFCompressionCCITTRLE)
		APPEND TO ARRAY:C911(pTIFFCodecBWNames;"None")
		APPEND TO ARRAY:C911(pTIFFCodecBWValues;kTIFFCompressionNone)
		
		ARRAY TEXT:C222(pTIFFCodecGrayNames;0)
		ARRAY LONGINT:C221(pTIFFCodecGrayValues;0)
		
		APPEND TO ARRAY:C911(pTIFFCodecGrayNames;"LZW")
		APPEND TO ARRAY:C911(pTIFFCodecGrayValues;kTIFFCompressionLZW)
		APPEND TO ARRAY:C911(pTIFFCodecGrayNames;"Deflate")
		APPEND TO ARRAY:C911(pTIFFCodecGrayValues;kTIFFCompressionDeflate)
		APPEND TO ARRAY:C911(pTIFFCodecGrayNames;"None")
		APPEND TO ARRAY:C911(pTIFFCodecGrayValues;kTIFFCompressionNone)
		
		ARRAY TEXT:C222(pTIFFCodecColorNames;0)
		ARRAY LONGINT:C221(pTIFFCodecColorValues;0)
		
		APPEND TO ARRAY:C911(pTIFFCodecColorNames;"LZW")
		APPEND TO ARRAY:C911(pTIFFCodecColorValues;kTIFFCompressionLZW)
		APPEND TO ARRAY:C911(pTIFFCodecColorNames;"Deflate")
		APPEND TO ARRAY:C911(pTIFFCodecColorValues;kTIFFCompressionDeflate)
		APPEND TO ARRAY:C911(pTIFFCodecColorNames;"None")
		APPEND TO ARRAY:C911(pTIFFCodecColorValues;kTIFFCompressionNone)
		
		COPY ARRAY:C226(pTIFFCodecBWNames;$tiffCodecBWPopupPtr->)
		COPY ARRAY:C226(pTIFFCodecGrayNames;$tiffCodecGrayPopupPtr->)
		COPY ARRAY:C226(pTIFFCodecColorNames;$tiffCodecColorPopupPtr->)
		
		  // ==================================
		  // Setup options
		
		If (OB Is defined:C1231(pFormatOptions;"TIFFMonochromeEncoding"))
			$tiffCodecBWPopupPtr->:=Find in array:C230(pTIFFCodecBWValues;\
				OB Get:C1224(pFormatOptions;"TIFFMonochromeEncoding";Is longint:K8:6))
		End if 
		If ($tiffCodecBWPopupPtr-><=0)
			$tiffCodecBWPopupPtr->:=1
		End if 
		
		If (OB Is defined:C1231(pFormatOptions;"TIFFGrayscaleEncoding"))
			$tiffCodecGrayPopupPtr->:=Find in array:C230(pTIFFCodecGrayValues;\
				OB Get:C1224(pFormatOptions;"TIFFGrayscaleEncoding";Is longint:K8:6))
		End if 
		If ($tiffCodecGrayPopupPtr-><=0)
			$tiffCodecGrayPopupPtr->:=1
		End if 
		
		If (OB Is defined:C1231(pFormatOptions;"TIFFColorEncoding"))
			$tiffCodecColorPopupPtr->:=Find in array:C230(pTIFFCodecColorValues;\
				OB Get:C1224(pFormatOptions;"TIFFColorEncoding";Is longint:K8:6))
		End if 
		If ($tiffCodecColorPopupPtr-><=0)
			$tiffCodecColorPopupPtr->:=1
		End if 
		
		C_BOOLEAN:C305($recompress)
		If (OB Is defined:C1231(pFormatOptions;"Recompress"))
			$recompress:=OB Get:C1224(pFormatOptions;"Recompress";Is boolean:K8:9)
		Else 
			$recompress:=False:C215
		End if 
		$jpegRecompressPtr->:=Num:C11($recompress)
		$jp2RecompressPtr->:=Num:C11($recompress)
		
		C_REAL:C285($quality)
		If (OB Is defined:C1231(pFormatOptions;"LossyCompressionQuality"))
			$quality:=OB Get:C1224(pFormatOptions;"LossyCompressionQuality";Is real:K8:4)
		Else 
			$quality:=0.75
		End if 
		$jpegQualityPtr->:=$quality*10
		$jp2QualityPtr->:=$quality*10
		
		C_BOOLEAN:C305($embedThumb)
		If (OB Is defined:C1231(pFormatOptions;"EmbedThumbnail"))
			$embedThumb:=OB Get:C1224(pFormatOptions;"EmbedThumbnail";Is boolean:K8:9)
		Else 
			$embedThumb:=False:C215
		End if 
		$jpegEmbedThumbPtr->:=Num:C11($embedThumb)
		$tiffEmbedThumbPtr->:=Num:C11($embedThumb)
		$jp2EmbedThumbPtr->:=Num:C11($embedThumb)
		$psdEmbedThumbPtr->:=Num:C11($embedThumb)
		
		  // Apply orientation
		
		$genericApplyOrientationPtr->:=1
		$jp2ApplyOrientationPtr->:=0
		$tiffApplyOrientationPtr->:=0
		$jp2ApplyOrientationPtr->:=0
		$psdApplyOrientationPtr->:=1
		
		If (OB Is defined:C1231(pFormatOptions;"ApplyOrientation"))
			
			C_BOOLEAN:C305($applyOrientation)
			$applyOrientation:=OB Get:C1224(pFormatOptions;"ApplyOrientation";Is boolean:K8:9)
			
			Case of 
				: ($selectedFormat="JPEG")
					$jp2ApplyOrientationPtr->:=Num:C11($applyOrientation)
				: ($selectedFormat="TIFF")
					$tiffApplyOrientationPtr->:=Num:C11($applyOrientation)
				: ($selectedFormat="JPEG 2000")
					$jp2ApplyOrientationPtr->:=Num:C11($applyOrientation)
				: ($selectedFormat="PSD")
					$psdApplyOrientationPtr->:=Num:C11($applyOrientation)
				Else 
					$genericApplyOrientationPtr->:=Num:C11($applyOrientation)
			End case 
			
		End if 
		
		  // ==================================
		  // Adjust options for source format
		
		C_TEXT:C284($docFormat)
		$docFormat:=ImgDoc_GetFormat:P11667:9 (pSaveDoc)
		
		C_OBJECT:C1216($docFormatInfo)
		$docFormatInfo:=ImgFormat_GetInfo ($docFormat)
		
		C_BOOLEAN:C305($docFormatIsLossy)
		$docFormatIsLossy:=(($docFormat="JPEG") | ($docFormat="JPEG 2000"))
		
		If ($docFormatIsLossy)
			
			C_LONGINT:C283($docMods)
			$docMods:=ImgDoc_GetEditsSummary:P11667:14 (pSaveDoc)
			If (($docMods & kRasterFramePixelsModified)#0)
				
				$jpegRecompressPtr->:=1
				$jp2RecompressPtr->:=1
				
				OBJECT SET ENABLED:C1123($jpegRecompressPtr->;False:C215)
				OBJECT SET ENABLED:C1123($jp2RecompressPtr->;False:C215)
				
			Else 
				
				$jpegRecompressPtr->:=0
				$jp2RecompressPtr->:=0
				
			End if 
			
		Else 
			
			$jpegRecompressPtr->:=1
			$jp2RecompressPtr->:=1
			
			OBJECT SET ENABLED:C1123($jpegRecompressPtr->;False:C215)
			OBJECT SET ENABLED:C1123($jp2RecompressPtr->;False:C215)
			
		End if 
		
		Case of 
			: (($selectedFormat="JPEG") & ($jpegApplyOrientationPtr->=1))
				
				$jpegRecompressPtr->:=1
				OBJECT SET ENABLED:C1123($jpegRecompressPtr->;False:C215)
				
			: (($selectedFormat="JPEG 2000") & ($jp2ApplyOrientationPtr->=1))
				
				$jp2RecompressPtr->:=1
				OBJECT SET ENABLED:C1123($jp2RecompressPtr->;False:C215)
				
		End case 
		
		OBJECT SET ENABLED:C1123($jpegQualityPtr->;$jpegRecompressPtr->=1)
		OBJECT SET ENABLED:C1123($jp2QualityPtr->;$jp2RecompressPtr->=1)
		
		
		
		OBJECT SET ENABLED:C1123($tiffCodecBWPopupPtr->;True:C214)
		OBJECT SET ENABLED:C1123($tiffCodecGrayPopupPtr->;True:C214)
		OBJECT SET ENABLED:C1123($tiffCodecColorPopupPtr->;True:C214)
		If (Not:C34(pSaveMultiframe))
			
			C_OBJECT:C1216($frameProps)
			$frameProps:=ImgFrame_GetProperties (pSaveDoc;1)
			
			If (OB Is defined:C1231($frameProps))
				
				C_TEXT:C284($colorModel)
				$colorModel:=OB Get:C1224($frameProps;"ColorModel";Is text:K8:3)
				
				Case of 
					: ($colorModel="Gray")
						
						C_LONGINT:C283($bitsPerChannel)
						$bitsPerChannel:=OB Get:C1224($frameProps;"BitsPerChannel";Is longint:K8:6)
						If ($bitsPerChannel=1)
							OBJECT SET ENABLED:C1123($tiffCodecBWPopupPtr->;True:C214)
							OBJECT SET ENABLED:C1123($tiffCodecGrayPopupPtr->;False:C215)
							OBJECT SET ENABLED:C1123($tiffCodecColorPopupPtr->;False:C215)
						Else 
							OBJECT SET ENABLED:C1123($tiffCodecBWPopupPtr->;False:C215)
							OBJECT SET ENABLED:C1123($tiffCodecGrayPopupPtr->;True:C214)
							OBJECT SET ENABLED:C1123($tiffCodecColorPopupPtr->;False:C215)
						End if 
						
					Else 
						
						OBJECT SET ENABLED:C1123($tiffCodecBWPopupPtr->;False:C215)
						OBJECT SET ENABLED:C1123($tiffCodecGrayPopupPtr->;False:C215)
						OBJECT SET ENABLED:C1123($tiffCodecColorPopupPtr->;True:C214)
						
				End case 
				
			End if 
			
		End if 
		
		
		  // ==================================
		
		Case of 
			: ($selectedFormat="JPEG")
				
				FORM GOTO PAGE:C247(2)
				
			: ($selectedFormat="TIFF")
				
				FORM GOTO PAGE:C247(3)
				
			: ($selectedFormat="JPEG 2000")
				
				FORM GOTO PAGE:C247(4)
				
			: ($selectedFormat="PSD")
				
				FORM GOTO PAGE:C247(5)
				
			Else 
				
				FORM GOTO PAGE:C247(1)
				
		End case 
		
		
End case 
