//%attributes = {"shared":true}
C_TEXT:C284($1;$pdfPath)  // @param: The full path to the PDF document in POSIX format. @optional
C_TEXT:C284($0;$pdfPassword)  // @param: The password entered by the user.

  // @desc: Requests a password from the user in order to unlock a PDF document.

  // @doc: Requests a password from the user in order to unlock a PDF document.
  // 
  // The optional parameter ``pdfPath`` is used for displaying the file name
  // of the PDF document in the password dialog. If specified, it must be in POSIX
  // format.
  // 
  // The password entered by the user is returned in ``pdfPassword``. If the user
  // cancels the dialog an empty string is returned.

If (Count parameters:C259>0)
	$pdfPath:=$1
End if 

$pdfPassword:=""

C_TEXT:C284(_pQ2PixPDFPath;_pQ2PixPDFPassword)
_pQ2PixPDFPath:=$pdfPath
_pQ2PixPDFPassword:=""

C_LONGINT:C283($window)
$window:=Open form window:C675("_PDFPassword";Movable form dialog box:K39:8)
DIALOG:C40("_PDFPassword")
If (OK=1)
	
	If (_pQ2PixPDFPassword#"")
		$pdfPassword:=_pQ2PixPDFPassword
	End if 
	
End if 

CLOSE WINDOW:C154($window)

If ($pdfPassword="")
	C_OBJECT:C1216($errInfo)
	OB SET:C1220($errInfo;"Domain";"Q2Pix";"Code";kQ2PixErrIntr;\
		"Method";Current method name:C684)
	ImgErr_SetInfo ($errInfo)
End if 

$0:=$pdfPassword
