//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_LONGINT:C283($0;$dataSize)  // @param: The document's data size.

  // @desc: Return the image document's byte size.

  // @doc: Return the byte size of the image document referenced by ``imgDocRef``.

ASSERT:C1129(Count parameters:C259=1)

$imgDocRef:=$1
$dataSize:=0

C_OBJECT:C1216($props)
$props:=ImgDoc_GetProperties ($imgDocRef)
If (OB Is defined:C1231($props))
	$dataSize:=OB Get:C1224($props;"FileSize";Is longint:K8:6)
End if 

$0:=$dataSize
