//%attributes = {}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the image frame. @optional
C_TEXT:C284($3;$format)  // @param: The picture format. @optional
C_PICTURE:C286($0;$framePict)  // @param: The frame picture

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 
If (Count parameters:C259>2)
	$format:=$3
Else 
	$format:=""
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

If ($format="")
	$format:=ImgDoc_GetFormat:P11667:9 ($imgDocRef)
End if 

If ($format="PDF")  // PDF creation TDB
	$format:=""
End if 

C_TEXT:C284($tempDocRef)
C_OBJECT:C1216($options)

If ($format#"")
	OB SET:C1220($options;"Format";$format)
End if 

$tempDocRef:=ImgDoc_CreateNew ($options)
If ($tempDocRef#"")
	
	If (ImgDoc_InsertFrame ($tempDocRef;1;$imgDocRef;$frameIdx)=1)
		
		C_BLOB:C604($frameBLOB)
		$frameBLOB:=ImgDoc_SaveInBLOB ($tempDocRef)
		
		If (BLOB size:C605($frameBLOB)>0)
			
			BLOB TO PICTURE:C682($frameBLOB;$framePict)
			
		End if 
		
	End if 
	
	ImgObj_Release:P11667:133 ($tempDocRef)
End if 

$0:=$framePict
