//%attributes = {"invisible":true}
C_POINTER:C301($1;$jsonTextPtr)
C_POINTER:C301($2;$valuePtr)
C_BOOLEAN:C305($0;$success)

C_LONGINT:C283(_gJSONParseError)
_gJSONParseError:=0

ARRAY LONGINT:C221(_gJSONParseErrorStackCodes;0)
ARRAY TEXT:C222(_gJSONParseErrorStackComponents;0)
ARRAY TEXT:C222(_gJSONParseErrorStackMessages;0)


If (Method called on error:C704=Current method name:C684)
	
	_gJSONParseError:=Error
	
	GET LAST ERROR STACK:C1015(_gJSONParseErrorStackCodes;\
		_gJSONParseErrorStackComponents;\
		_gJSONParseErrorStackMessages)
	
	If (Not:C34(Is compiled mode:C492(*)))
		
		C_TEXT:C284($errorMessage)
		$errorMessage:=Current method name:C684+": error parsing JSON: "+String:C10(_gJSONParseError)
		$errorMessage:=$errorMessage+"\n\n"
		
		C_LONGINT:C283($idx)
		For ($idx;1;Size of array:C274(_gJSONParseErrorStackMessages))
			$errorMessage:=$errorMessage+_gJSONParseErrorStackMessages{$idx}+"\n"
		End for 
		
		ALERT:C41($errorMessage)
		TRACE:C157
	End if 
	
Else 
	
	$jsonTextPtr:=$1
	$valuePtr:=$2
	
	$success:=False:C215
	
	If (Length:C16($jsonTextPtr->)>0)
		
		C_LONGINT:C283($valueType)
		$valueType:=Type:C295($valuePtr->)
		
		Case of 
			: (($valueType=Is boolean:K8:9) | ($valueType=Is date:K8:7)\
				 | ($valueType=Is longint:K8:6) | ($valueType=Is object:K8:27)\
				 | ($valueType=Is real:K8:4) | ($valueType=Is text:K8:3))
				
				C_TEXT:C284($oldErrHandler)
				$oldErrHandler:=Method called on error:C704
				ON ERR CALL:C155(Current method name:C684)
				
				$valuePtr->:=JSON Parse:C1218($jsonTextPtr->;$valueType)
				
				ON ERR CALL:C155($oldErrHandler)
				
				$success:=(_gJSONParseError=0)
				
			: (($valueType=Boolean array:K8:21) | ($valueType=Object array:K8:28)\
				 | ($valueType=Pointer array:K8:23) | ($valueType=Real array:K8:17)\
				 | ($valueType=Text array:K8:16))
				
				
				C_TEXT:C284($oldErrHandler)
				$oldErrHandler:=Method called on error:C704
				ON ERR CALL:C155(Current method name:C684)
				
				JSON PARSE ARRAY:C1219($jsonTextPtr->;$valuePtr->)
				
				ON ERR CALL:C155($oldErrHandler)
				
				$success:=(_gJSONParseError=0)
				
		End case 
		
	End if 
	
	$0:=$success
	
End if 

