//%attributes = {"shared":true}
C_REAL:C285($1; $x)  // @param: The object's X coordinate.
C_REAL:C285($2; $y)  // @param: The object's Y coordinate.
C_OBJECT:C1216($0; $pointObj)  // @param: The ``PointObj`` object.

// @desc: Make a PointObj object.

// @doc: Make a ``PointObj`` object.
//
// The X and Y coordinates of the point object are passed in the ``x`` and ``y``
// parameters respectively.
//
// The ``PointObj`` object is returned in ``pointObj``.
//

ASSERT:C1129(Count parameters:C259=2)

$x:=$1
$y:=$2

$pointObj:=New object:C1471()
OB SET:C1220($pointObj; "X"; $x; "Y"; $y)

$0:=$pointObj

