//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_REAL:C285($0;$width)  // @param: The width of ``rectObj``.

  // @desc: Return the width of a RectObj object.

  // @doc: Return the width of a ``RectObj`` object.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The width of ``rectObj`` is returned in ``width``.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1
$width:=0

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

$width:=OB Get:C1224($rectObj;"Width";Is real:K8:4)

$0:=$width
