//%attributes = {"shared":true}
C_REAL:C285($1; $x)  // @param: The object's origin X coordinate.
C_REAL:C285($2; $y)  // @param: The object's origin Y coordinate.
C_REAL:C285($3; $width)  // @param: The object's width.
C_REAL:C285($4; $height)  // @param: The object's height.
C_OBJECT:C1216($0; $rectObj)  // @param: The ``RectObj`` object.

// desc: Make a RectObj object.

// doc: Make a ``RectObj`` object.
//
// The rect's origin is specified by the ``x`` and ``y`` parameters,
// and its size by ``width`` and ``height`` respectively.
//
// The ``RectObj`` object is returned in ``rect``.
//

ASSERT:C1129(Count parameters:C259=4)

$x:=$1
$y:=$2
$width:=$3
$height:=$4

$rectObj:=New object:C1471()

OB SET:C1220($rectObj; "X"; $x; "Y"; $y; "Width"; $width; "Height"; $height)

$0:=$rectObj
