//%attributes = {}
C_POINTER:C301($effectPopupPtr)
$effectPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"effect_popup")

C_LONGINT:C283($effectIdx)
$effectIdx:=$effectPopupPtr->

C_TEXT:C284($effectName)
$effectName:=pEffectNames{$effectIdx}

C_OBJECT:C1216($effectSpec)
$effectSpec:=OB Get:C1224(pDialogEffects;$effectName;Is object:K8:27)

C_OBJECT:C1216($effectParams)
$effectParams:=OB Get:C1224($effectSpec;"Params";Is object:K8:27)

C_OBJECT:C1216($paramValues)
$paramValues:=OB Get:C1224($effectSpec;"ParamValues";Is object:K8:27)

C_LONGINT:C283($effectPage)
$effectPage:=OB Get:C1224($effectSpec;"Page";Is longint:K8:6)

C_OBJECT:C1216($formBindings)
$formBindings:=OB Get:C1224($effectSpec;"Bindings";Is object:K8:27)

ARRAY TEXT:C222($formObjects;0)
OB GET PROPERTY NAMES:C1232($formBindings;$formObjects)

C_LONGINT:C283($idx;$count)
$count:=Size of array:C274($formObjects)

For ($idx;1;$count)
	
	C_TEXT:C284($objectName)
	$objectName:=$formObjects{$idx}
	
	C_POINTER:C301($objectPtr)
	$objectPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$objectName)
	
	C_OBJECT:C1216($objectBinding)
	$objectBinding:=OB Get:C1224($formBindings;$objectName;Is object:K8:27)
	
	C_TEXT:C284($paramName)
	$paramName:=OB Get:C1224($objectBinding;"Param";Is text:K8:3)
	
	C_OBJECT:C1216($paramDef)
	$paramDef:=OB Get:C1224($effectParams;$paramName;Is object:K8:27)
	
	C_LONGINT:C283($objectType)
	$objectType:=OBJECT Get type:C1300(*;$objectName)
	
	Case of 
		: ($objectType=Object type checkbox:K79:26)
			
			C_BOOLEAN:C305($boolVal)
			$boolVal:=OB Get:C1224($paramValues;$paramName;Is boolean:K8:9)
			
			$objectPtr->:=Choose:C955($boolVal;1;0)
			
		: ($objectType=Object type ruler:K79:30)
			
			C_REAL:C285($realVal)
			$realVal:=OB Get:C1224($paramValues;$paramName;Is real:K8:4)
			
			C_REAL:C285($minVal;$maxVal)
			$minVal:=OB Get:C1224($paramDef;"Minimum";Is real:K8:4)
			$maxVal:=OB Get:C1224($paramDef;"Maximum";Is real:K8:4)
			
			C_REAL:C285($scale)
			$scale:=OB Get:C1224($objectBinding;"Scale";Is real:K8:4)
			
			C_LONGINT:C283($sliderVal;$sliderMin;$sliderMax)
			$sliderVal:=$realVal*$scale
			$sliderMin:=$minVal*$scale
			$sliderMax:=$maxVal*$scale
			
			C_LONGINT:C283($sliderUnit;$sliderStep)
			$sliderUnit:=10
			$sliderStep:=1
			
			C_TEXT:C284($sliderFormat)
			$sliderFormat:=String:C10($sliderMin)+";"+String:C10($sliderMax)+";"+String:C10($sliderUnit)+";"+String:C10($sliderStep)+";"+"2"
			
			OBJECT SET FORMAT:C236(*;$objectName;$sliderFormat)
			$objectPtr->:=$sliderVal
			
	End case 
	
End for 

_EffectDlog_UpdateState 

FORM GOTO PAGE:C247($effectPage)

_EffectDlog_BuildPreview 
