//%attributes = {}
C_TEXT:C284($1; $message)
C_OBJECT:C1216($2; $args)

$message:=$1
If (Count parameters:C259>1)
	$args:=$2
End if 

If (True:C214)
	
	C_POINTER:C301($pixelWidthPtr; $pixelHeightPtr)
	$pixelWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "pixel_width")
	$pixelHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "pixel_height")
	
	C_POINTER:C301($pointWidthPtr; $pointHeightPtr)
	$pointWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "point_width")
	$pointHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "point_height")
	
	C_POINTER:C301($percentWidthPtr; $percentHeightPtr)
	$percentWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "percent_width")
	$percentHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "percent_height")
	
	C_POINTER:C301($sizeUnitsPtr)
	$sizeUnitsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "size_units")
	
	C_POINTER:C301($dpiWidthPtr; $dpiHeightPtr)
	$dpiWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "dpi_width")
	$dpiHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "dpi_height")
	
	C_POINTER:C301($resamplePtr)
	$resamplePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "resample")
	
	C_POINTER:C301($propSizePtr; $propResPtr; $propBothPtr)
	$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
	$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
	$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
	
	C_POINTER:C301($currentPixelsPtr; $currentPointsPtr; $currentDPIPtr)
	$currentPixelsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "current_pixels")
	$currentPointsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "current_points")
	$currentDPIPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "current_dpi")
	
	C_POINTER:C301($resultPixelsPtr; $resultPointsPtr; $resultDPIPtr)
	$resultPixelsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "result_pixels")
	$resultPointsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "result_points")
	$resultDPIPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "result_dpi")
	
	C_LONGINT:C283($pixelWidth; $pixelHeight)
	C_REAL:C285($dpiWidth; $dpiHeight)
	C_REAL:C285($pointWidth; $pointHeight)
	C_REAL:C285($percentWidth; $percentHeight)
	
	C_BOOLEAN:C305($propSize; $propRes; $resample)
	
	C_OBJECT:C1216(pImgSizeCtx)
	
End if 

Case of 
	: ($message="update_prop_size_state")
		
		$resample:=$resamplePtr->=1
		If ($resample)
			
			C_BOOLEAN:C305($value; $enabled)
			$value:=(($propSizePtr-> & 0x0001)#0)
			$enabled:=(($propSizePtr-> & 0x0002)=0)
			
			OBJECT SET RGB COLORS:C628(*; "prop_size_line_@"; Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
			OBJECT SET ENABLED:C1123(*; "prop_size"; $enabled)
			
		End if 
		
	: ($message="update_prop_res_state")
		
		$resample:=$resamplePtr->=1
		If ($resample)
			
			C_BOOLEAN:C305($value; $enabled)
			$value:=(($propResPtr-> & 0x0001)#0)
			$enabled:=(($propResPtr-> & 0x0002)=0)
			
			OBJECT SET RGB COLORS:C628(*; "prop_res_line_@"; Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
			OBJECT SET ENABLED:C1123(*; "prop_res"; $enabled)
			
		End if 
		
	: ($message="update_prop_both_state")
		
		$resample:=$resamplePtr->=1
		If (Not:C34($resample))
			
			C_BOOLEAN:C305($value; $enabled)
			$value:=($propBothPtr-> & 0x0001)#0
			$enabled:=($propBothPtr-> & 0x0002)=0
			
			OBJECT SET RGB COLORS:C628(*; "prop_size_line_@"; Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
			OBJECT SET RGB COLORS:C628(*; "prop_res_line_@"; Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
			OBJECT SET RGB COLORS:C628(*; "prop_both_line_@"; Choose:C955($value; 0x0000; 0x00FFFFFF); Choose:C955($value; 0x0000; 0x00FFFFFF))
			OBJECT SET ENABLED:C1123(*; "prop_both"; $enabled)
			
		End if 
		
	: ($message="update_resample_state")
		
		$resample:=$resamplePtr->=1
		
		OBJECT SET VISIBLE:C603(*; "prop_both"; Not:C34($resample))
		OBJECT SET VISIBLE:C603(*; "prop_both_line_@"; Not:C34($resample))
		OBJECT SET VISIBLE:C603(*; "prop_size"; $resample)
		OBJECT SET VISIBLE:C603(*; "prop_res"; $resample)
		
	: ($message="update_units_state")
		
		$resample:=$resamplePtr->=1
		
		C_LONGINT:C283($unitID)
		$unitID:=Selected list items:C379($sizeUnitsPtr->; *)
		
		If (Is a list:C621($sizeUnitsPtr->))
			CLEAR LIST:C377($sizeUnitsPtr->; *)
		End if 
		$sizeUnitsPtr->:=Load list:C383(\
			Choose:C955($resample; \
			"Image Size Units - Resample"; \
			"Image Size Units - No Resample"))
		
		SELECT LIST ITEMS BY REFERENCE:C630($sizeUnitsPtr->; $unitID)
		$unitID:=Selected list items:C379($sizeUnitsPtr->; *)
		If ($unitID=0)
			SELECT LIST ITEMS BY POSITION:C381(*; "size_units"; 1)
			$unitID:=Selected list items:C379($sizeUnitsPtr->; *)
		End if 
		
	: ($message="update_size_values")
		
		C_LONGINT:C283($unitID)
		$unitID:=Selected list items:C379($sizeUnitsPtr->; *)
		
		$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is longint:K8:6)
		$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is longint:K8:6)
		
		$dpiWidth:=OB Get:C1224(pImgSizeCtx; "dpi_width"; Is longint:K8:6)
		$dpiHeight:=OB Get:C1224(pImgSizeCtx; "dpi_height"; Is longint:K8:6)
		
		OBJECT SET VISIBLE:C603(*; "pixel_width"; False:C215)
		OBJECT SET VISIBLE:C603(*; "pixel_height"; False:C215)
		OBJECT SET VISIBLE:C603(*; "point_width"; False:C215)
		OBJECT SET VISIBLE:C603(*; "point_height"; False:C215)
		OBJECT SET VISIBLE:C603(*; "percent_width"; False:C215)
		OBJECT SET VISIBLE:C603(*; "percent_height"; False:C215)
		
		Case of 
			: ($unitID=1)  // Pixels
				
				$pixelWidthPtr->:=$pixelWidth
				$pixelHeightPtr->:=$pixelHeight
				
				OBJECT SET VISIBLE:C603(*; "pixel_width"; True:C214)
				OBJECT SET VISIBLE:C603(*; "pixel_height"; True:C214)
				
			: ($unitID=2)  // Points
				
				$pointWidth:=($pixelWidth/$dpiWidth)*72
				$pointHeight:=($pixelHeight/$dpiHeight)*72
				
				$pointWidthPtr->:=$pointWidth
				$pointHeightPtr->:=$pointHeight
				
				OBJECT SET VISIBLE:C603(*; "point_width"; True:C214)
				OBJECT SET VISIBLE:C603(*; "point_height"; True:C214)
				
			: ($unitID=3)  // Percent
				
				OBJECT SET VISIBLE:C603(*; "percent_width"; True:C214)
				OBJECT SET VISIBLE:C603(*; "percent_height"; True:C214)
				
		End case 
		
	: ($message="update_res_values")
		
		$dpiWidth:=OB Get:C1224(pImgSizeCtx; "dpi_width"; Is real:K8:4)
		$dpiHeight:=OB Get:C1224(pImgSizeCtx; "dpi_height"; Is real:K8:4)
		
		$dpiWidthPtr->:=$dpiWidth
		$dpiHeightPtr->:=$dpiHeight
		
	: ($message="reset")
		
		$resamplePtr->:=1
		$propSizePtr->:=1  // Locked/enabled
		$propResPtr->:=1  // Locked/enabled
		$propBothPtr->:=0  // Unlocked/enabled
		
		//$resamplePtr->:=0
		//$propSizePtr->:=1  // Locked/enabled
		//$propResPtr->:=1  // Locked/enabled
		
		$pixelWidth:=SizeObj_GetWidth(pPixelSize)
		$pixelHeight:=SizeObj_GetHeight(pPixelSize)
		
		$dpiWidth:=SizeObj_GetWidth(pDPISize)
		$dpiHeight:=SizeObj_GetHeight(pDPISize)
		
		pImgSizeCtx:=New object:C1471()
		OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
		OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
		
		OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
		OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
		
		_RasterSize_Handler("update_resample_state")
		_RasterSize_Handler("update_prop_size_state")
		_RasterSize_Handler("update_prop_res_state")
		_RasterSize_Handler("update_prop_both_state")
		
		_RasterSize_Handler("update_units_state")
		
		_RasterSize_Handler("update_size_values")
		_RasterSize_Handler("update_res_values")
		
	: ($message="update_current_size")
		
		$pixelWidth:=SizeObj_GetWidth(pPixelSize)
		$pixelHeight:=SizeObj_GetHeight(pPixelSize)
		
		$dpiWidth:=SizeObj_GetWidth(pDPISize)
		$dpiHeight:=SizeObj_GetHeight(pDPISize)
		
		$pointWidth:=($pixelWidth/$dpiWidth)*72
		$pointHeight:=($pixelHeight/$dpiHeight)*72
		
		C_TEXT:C284($dpiFormat; $pointFormat)
		$dpiFormat:="########0.0"
		$pointFormat:="########0.0"
		
		$currentPixelsPtr->:=String:C10($pixelWidth)+" x "+String:C10($pixelHeight)+" pixels"
		$currentPointsPtr->:=String:C10($pointWidth; $pointFormat)+" x "+String:C10($pointHeight; $pointFormat)+" points"
		$currentDPIPtr->:=String:C10($dpiWidth; $dpiFormat)+" x "+String:C10($dpiHeight; $dpiFormat)+" DPI"
		
	: ($message="update_result_size")
		
		If (OB Is defined:C1231($args))
			
			$pixelWidth:=OB Get:C1224($args; "pixel_width"; Is longint:K8:6)
			$pixelHeight:=OB Get:C1224($args; "pixel_height"; Is longint:K8:6)
			
			$dpiWidth:=OB Get:C1224($args; "dpi_width"; Is longint:K8:6)
			$dpiHeight:=OB Get:C1224($args; "dpi_height"; Is longint:K8:6)
			
		Else 
			
			$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is longint:K8:6)
			$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is longint:K8:6)
			
			$dpiWidth:=OB Get:C1224(pImgSizeCtx; "dpi_width"; Is longint:K8:6)
			$dpiHeight:=OB Get:C1224(pImgSizeCtx; "dpi_height"; Is longint:K8:6)
			
		End if 
		
		$pointWidth:=($pixelWidth/$dpiWidth)*72
		$pointHeight:=($pixelHeight/$dpiHeight)*72
		
		C_TEXT:C284($dpiFormat; $pointFormat)
		$dpiFormat:="########0.0"
		$pointFormat:="########0.0"
		
		$resultPixelsPtr->:=String:C10($pixelWidth)+" x "+String:C10($pixelHeight)+" pixels"
		$resultPointsPtr->:=String:C10($pointWidth; $pointFormat)+" x "+String:C10($pointHeight; $pointFormat)+" points"
		$resultDPIPtr->:=String:C10($dpiWidth; $dpiFormat)+" x "+String:C10($dpiHeight; $dpiFormat)+" DPI"
		
	: ($message="validate_form")
		
		$pixelWidth:=$pixelWidthPtr->
		$pixelHeight:=$pixelHeightPtr->
		
		$dpiWidth:=$dpiWidthPtr->
		$dpiHeight:=$dpiHeightPtr->
		
		C_BOOLEAN:C305($valid)
		$valid:=(($pixelWidth>0) & ($pixelHeight>0) & ($dpiWidth>=1) & ($dpiHeight>=1))
		
		OBJECT SET ENABLED:C1123(*; "ok_button"; $valid)
		
	: ($message="store_values")
		
		$pixelWidth:=$pixelWidthPtr->
		$pixelHeight:=$pixelHeightPtr->
		
		$dpiWidth:=$dpiWidthPtr->
		$dpiHeight:=$dpiHeightPtr->
		
		pPixelSize:=SizeObj_New($pixelWidth; $pixelHeight)
		pDPISize:=SizeObj_New($dpiWidth; $dpiHeight)
		
	Else 
		
		ASSERT:C1129(False:C215; "Unhandled message: "+$message)
		
End case 

