//%attributes = {}
C_TEXT:C284($dbFolderSysPath)
$dbFolderSysPath:=Get 4D folder:C485(Database folder:K5:14)

C_OBJECT:C1216($databaseDirRef)
$databaseDirRef:=FSRef_InitWithSystemPath($dbFolderSysPath)

If (FSRef_GetExtension($databaseDirRef)="4dbase")
	
	C_TEXT:C284($componentName)
	$componentName:=FSRef_GetName(FSRef_SetExtension($databaseDirRef; ""))
	
	C_OBJECT:C1216($projectFileRef)
	$projectFileRef:=FSRef_AppendName($databaseDirRef; "Build.xml")
	
	C_OBJECT:C1216($buildDirsRef)
	$buildDirsRef:=FSRef_GetParent(FSRef_GetParent($databaseDirRef))
	//$buildDirsRef:=FSRef_AppendName ($buildDirsRef;"_build")
	
	
	
	C_TEXT:C284($xmlRoot)
	$xmlRoot:=DOM Create XML Ref:C861("Preferences4D")
	DOM SET XML ELEMENT VALUE:C868(DOM Create XML element:C865($xmlRoot; "/Preferences4D/BuildApp/BuildComponent"); "True")
	DOM SET XML ELEMENT VALUE:C868(DOM Create XML element:C865($xmlRoot; "/Preferences4D/BuildApp/BuildCompiled"); "False")
	DOM SET XML ELEMENT VALUE:C868(DOM Create XML element:C865($xmlRoot; "/Preferences4D/BuildApp/CS/BuildServerApplication"); "False")
	DOM SET XML ELEMENT VALUE:C868(DOM Create XML element:C865($xmlRoot; "/Preferences4D/BuildApp/BuildApplicationName"); $componentName)
	DOM SET XML ELEMENT VALUE:C868(DOM Create XML element:C865($xmlRoot; "/Preferences4D/BuildApp/BuildMacDestFolder"); FSRef_GetSystemPath($buildDirsRef))
	DOM EXPORT TO FILE:C862($xmlRoot; FSRef_GetSystemPath($projectFileRef))
	DOM CLOSE XML:C722($xmlRoot)
	
	If (FSRef_IsFile($projectFileRef))
		
		BUILD APPLICATION:C871(FSRef_GetSystemPath($projectFileRef))
		
		If (OK=1)
			
			C_OBJECT:C1216($srcInfoPlistFileRef)
			$srcInfoPlistFileRef:=FSRef_AppendNameArgs($databaseDirRef; "Contents"; "Info.plist")
			
			If (FSRef_IsFile($srcInfoPlistFileRef))
				
				C_OBJECT:C1216($dstContentsDirRef; $dstInfoPlistFileRef)
				$dstContentsDirRef:=FSRef_AppendNameArgs($buildDirsRef; "Components"; $componentName+".4dbase"; "Contents")
				$dstInfoPlistFileRef:=FSRef_AppendName($dstContentsDirRef; "Info.plist")
				
				FSRef_CreateDirs($dstContentsDirRef)
				
				If (FSRef_IsDir($dstContentsDirRef))
					
					COPY DOCUMENT:C541(FSRef_GetSystemPath($srcInfoPlistFileRef); FSRef_GetSystemPath($dstInfoPlistFileRef))
					
				End if 
				
			End if 
			
		Else 
			ALERT:C41("Failed to build project: "+FSRef_GetPOSIXPath($projectFileRef))
		End if 
		
		ALERT:C41("Done!")
		
	Else 
		ALERT:C41("Failed to save build project: "+FSRef_GetPOSIXPath($projectFileRef))
	End if 
	
Else 
	ALERT:C41("This project is not bundled as a '.4dbase' folder.")
End if 

