//%attributes = {"shared":true}
C_LONGINT:C283($1; $folderType)
C_OBJECT:C1216($0; $fsRef)

$folderType:=$1

C_BOOLEAN:C305($isSystemPath; $validSelector)
$isSystemPath:=True:C214
$validSelector:=True:C214

Case of 
	: ($folderType=4D Client database folder:K5:13)
		
	: ($folderType=Active 4D Folder:K5:10)
		
	: ($folderType=Current resources folder:K5:16)
		
	: ($folderType=Database folder:K5:14)
		
	: ($folderType=Database folder UNIX syntax:K5:15)
		
		$isSystemPath:=False:C215
		
	: ($folderType=_o_Extras folder:K5:12)
		
	: ($folderType=HTML Root folder:K5:20)
		
	: ($folderType=Licenses folder:K5:11)
		
	: ($folderType=Logs folder:K5:19)
		
	Else 
		
		$validSelector:=False:C215
		
End case 

If ($validSelector)
	
	C_TEXT:C284($folderPath)
	$folderPath:=Get 4D folder:C485($folderType; *)
	
	If ($folderPath#"")
		
		If ($isSystemPath)
			$folderPath:=Convert path system to POSIX:C1106($folderPath)
		End if 
		
		$fsRef:=FSRef__InitWithPath($folderPath)
		
	End if 
	
End if 

$0:=$fsRef
