//%attributes = {"shared":true}
C_LONGINT:C283($1; $folderType)
C_OBJECT:C1216($0; $fsRef)

If (Count parameters:C259>0)
	$folderType:=$1
Else 
	$folderType:=System:K41:1
End if 

C_BOOLEAN:C305($folderTypeValid)
$folderTypeValid:=True:C214

Case of 
	: ($folderType=Applications or program files:K41:17)
		
	: ($folderType=Desktop:K41:16)
		
	: ($folderType=Documents folder:K41:18)
		
	: ($folderType=Fonts:K41:2)
		
	: ($folderType=System:K41:1)
		
	: ($folderType=User preferences_all:K41:3)
		
	: ($folderType=User preferences_user:K41:4)
		
	Else 
		
		If (Platform_IsWindows)
			
			Case of 
				: ($folderType=Favorites Win:K41:15)
					
				: ($folderType=Start menu Win_all:K41:9)
					
				: ($folderType=Start menu Win_user:K41:10)
					
				: ($folderType=Startup Win_all:K41:5)
					
				: ($folderType=Startup Win_user:K41:6)
					
				: ($folderType=System Win:K41:13)
					
				: ($folderType=System32 Win:K41:14)
					
				Else 
					$folderTypeValid:=False:C215
			End case 
			
		Else 
			$folderTypeValid:=False:C215
		End if 
		
End case 

If ($folderTypeValid)
	
	C_TEXT:C284($systemPath)
	$systemPath:=System folder:C487($folderType)
	If ($systemPath#"")
		
		$systemPath:=Convert path system to POSIX:C1106($systemPath)
		
		$fsRef:=FSRef__InitWithPath($systemPath)
		
	End if 
	
End if 

$0:=$fsRef
