//%attributes = {"shared":true}
C_TEXT:C284($1; $pattern)
C_TEXT:C284($2; $target)
C_TEXT:C284($3; $groups)
C_POINTER:C301($4; $segArrayPtr)
//C_BOOLEAN($0;$success)

$pattern:=$1
$target:=$2
$groups:=$3
$segArrayPtr:=$4
//$success:=False

Array_Clear($segArrayPtr)

C_BOOLEAN:C305($extract1D)
$extract1D:=False:C215

ARRAY TEXT:C222($groupSpecs; 0)
String_Split($groups; " "; ->$groupSpecs)

C_LONGINT:C283($groupCount)
$groupCount:=Size of array:C274($groupSpecs)

ARRAY LONGINT:C221($groupNums; $groupCount)

C_LONGINT:C283($idx)

For ($idx; 1; $groupCount)
	$groupNums{$idx}:=Num:C11($groupSpecs{$idx})
End for 

C_BOOLEAN:C305($hasGroups)
$hasGroups:=($groupCount>0)

C_LONGINT:C283($arrayType)
$arrayType:=Type:C295($segArrayPtr->)

C_BOOLEAN:C305($paramsOK)
$paramsOK:=True:C214

If ($paramsOK)
	
	Case of 
		: ($arrayType=Text array:K8:16)
			// OK
			$extract1D:=True:C214
			
		: ($arrayType=Array 2D:K8:24)
			
			C_BLOB:C604($arrayRowBLOB)
			VARIABLE TO BLOB:C532($segArrayPtr->{0}; $arrayRowBLOB)
			
			C_LONGINT:C283($elemType)
			$elemType:=$arrayRowBLOB{4}
			If ($elemType=34)  //Text array compat
				// OK
				$extract1D:=False:C215
			Else 
				$paramsOK:=False:C215
			End if 
			
		Else 
			$paramsOK:=False:C215
			
	End case 
	
End if 

C_LONGINT:C283($targetLength)
$targetLength:=Length:C16($target)

If ($paramsOK)
	
	C_TEXT:C284($aSeg)
	C_LONGINT:C283($aGroupNum)
	
	C_LONGINT:C283($start)
	$start:=1
	
	While ($start<=$targetLength)
		
		ARRAY LONGINT:C221($matchedGroupOffsets; 0)
		ARRAY LONGINT:C221($matchedGroupLengths; 0)
		
		If (Match regex:C1019($pattern; $target; $start; $matchedGroupOffsets; $matchedGroupLengths))
			
			C_LONGINT:C283($matchOffset; $matchLength)
			$matchOffset:=$matchedGroupOffsets{0}
			$matchLength:=$matchedGroupLengths{0}
			
			C_LONGINT:C283($matchedGroupCount)
			$matchedGroupCount:=Size of array:C274($matchedGroupOffsets)
			
			Case of 
				: ($extract1D)
					
					If ($hasGroups)
						$aGroupNum:=$groupNums{1}
						If (($aGroupNum>=0) & ($aGroupNum<=$matchedGroupCount))
							$aSeg:=Substring:C12($target; $matchedGroupOffsets{$aGroupNum}; $matchedGroupLengths{$aGroupNum})
						Else 
							$aSeg:=Substring:C12($target; $matchOffset; $matchLength)
						End if 
					Else 
						$aSeg:=Substring:C12($target; $matchOffset; $matchLength)
					End if 
					
					APPEND TO ARRAY:C911($segArrayPtr->; $aSeg)
					
				Else   // 2D
					
					If ($hasGroups)
						
						ARRAY TEXT:C222($segRowArray; $groupCount)
						
						C_LONGINT:C283($segIdx)
						For ($segIdx; 1; $groupCount)
							
							$aGroupNum:=$groupNums{$segIdx}
							If (($aGroupNum>=0) & ($aGroupNum<=$matchedGroupCount))
								$aSeg:=Substring:C12($target; $matchedGroupOffsets{$aGroupNum}; $matchedGroupLengths{$aGroupNum})
							Else 
								$aSeg:=Substring:C12($target; $matchOffset; $matchLength)
							End if 
							
							$segRowArray{$segIdx}:=$aSeg
							
						End for 
						
					Else 
						
						ARRAY TEXT:C222($segRowArray; $matchedGroupCount)
						
						C_LONGINT:C283($groupIdx)
						For ($groupIdx; 0; $matchedGroupCount)
							
							$aSeg:=Substring:C12($target; $matchedGroupOffsets{$groupIdx}; $matchedGroupLengths{$groupIdx})
							
							$segRowArray{$groupIdx}:=$aSeg
							
						End for 
						
					End if 
					
					C_LONGINT:C283($rowIdx)
					$rowIdx:=Size of array:C274($segArrayPtr->)+1
					
					INSERT IN ARRAY:C227($segArrayPtr->; $rowIdx)
					COPY ARRAY:C226($segRowArray; $segArrayPtr->{$rowIdx})
					
			End case 
			
			$start:=$matchOffset+$matchLength
			If ($matchLength=0)
				// Advance start for zero-length matches, otherwise
				// we'll get into an infinite loop.
				$start:=1
			End if 
			
		Else   // No match
			$start:=$targetLength+1  // Break
		End if 
		
	End while 
	
	//$success:=True
	
End if 

//$0:=$success

