//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_LONGINT:C283($3;$event)

$paneContext:=$1
$propName:=$2
$event:=$3

Case of 
	: ($propName="@_add")
		
		$propName:=Substring:C12($propName;1;Length:C16($propName)-Length:C16("_add"))
		
		C_TEXT:C284($menuRef)
		$menuRef:=LangAlt_BuildMenu ($propName)
		
		C_REAL:C285($mouseX;$mouseY)
		C_LONGINT:C283($mouseDown)
		GET MOUSE:C468($mouseX;$mouseY;$mouseDown)
		
		C_LONGINT:C283($popupX;$popupY)
		  //$popupX:=$paneLeft+$buttonLeft
		  //$popupY:=$paneTop+$buttonBottom-4
		$popupX:=$mouseX
		$popupY:=$mouseY
		
		C_TEXT:C284($command)
		$command:=Dynamic pop up menu:C1006($menuRef;"";$popupX;$popupY)
		
		RELEASE MENU:C978($menuRef)
		
		If ($command#"")
			
			C_POINTER:C301($langCodesPtr)
			$langCodesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_lang_code")
			
			C_TEXT:C284($newLangCode)
			$newLangCode:=""
			
			Case of 
				: ($command="other")
					
					$newLangCode:=LangAlt_SelectLanguage ($langCodesPtr)
					
				Else 
					
					$newLangCode:=$command
					
			End case 
			
			If ($newLangCode#"")
				
				C_TEXT:C284($newLangTitle)
				$newLangTitle:=OB Get:C1224(<>gXMPLangsByID;$newLangCode;Is text:K8:3)
				If ($newLangTitle="")
					$newLangTitle:=$newLangCode
				End if 
				
				C_LONGINT:C283($rowCount;$rowIdx)
				$rowCount:=Size of array:C274($langCodesPtr->)
				$rowIdx:=$rowCount+1
				
				C_POINTER:C301($langTitlesPtr)
				$langTitlesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_lang_title")
				
				LISTBOX INSERT ROWS:C913(*;$propName;$rowIdx;1)
				
				$langCodesPtr->{$rowIdx}:=$newLangCode
				$langTitlesPtr->{$rowIdx}:=$newLangTitle
				
				LISTBOX SELECT ROW:C912(*;$propName;$rowIdx;lk replace selection:K53:1)
				OBJECT SET SCROLL POSITION:C906(*;$propName;$rowIdx;2)
				EDIT ITEM:C870(*;$propName+"_value";$rowIdx)
				
			End if 
			
		End if 
		
	: ($propName="@_del")
		
		$propName:=Substring:C12($propName;1;Length:C16($propName)-Length:C16("_del"))
		
		If (LangAlt_CanDelete ($propName))
			
			C_LONGINT:C283($selectedRow)
			$selectedRow:=ListBox_GetSelection ($propName)
			
			LISTBOX DELETE ROWS:C914(*;$propName;$selectedRow)
			
			C_OBJECT:C1216($propSpec)
			$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
			
			LangAlt_Store ($paneContext;$propName;$propSpec)
			
			LangAlt_Load ($paneContext;$propName;$propSpec)
			
			OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
			
		End if 
		
	Else   // Listbox
		
		Case of 
			: ($event=On Selection Change:K2:29)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					OBJECT SET ENABLED:C1123(*;$propName+"_del";LangAlt_CanDelete ($propName))
				End if 
				
			: ($event=On Losing Focus:K2:8)
				
				C_LONGINT:C283($col;$row)
				LISTBOX GET CELL POSITION:C971(*;$propName;$col;$row)
				
				LISTBOX SELECT ROW:C912(*;$propName;0;lk remove from selection:K53:3)
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					OBJECT SET ENABLED:C1123(*;$propName+"_del";LangAlt_CanDelete ($propName))
				End if 
				
			: ($event=On Before Data Entry:K2:39)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
				End if 
				
			: ($event=On Delete Action:K2:56)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					LangAlt_Event ($paneContext;$propName+"_del";On Clicked:K2:4)
				End if 
				
			: ($event=On Data Change:K2:15)
				
				C_LONGINT:C283($col;$row)
				LISTBOX GET CELL POSITION:C971(*;$propName;$col;$row)
				
				C_OBJECT:C1216($propSpec)
				$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
				
				LangAlt_Store ($paneContext;$propName;$propSpec)
				
				LangAlt_Load ($paneContext;$propName;$propSpec)
				
				EDIT ITEM:C870(*;$propName+"_lang_title";$row)
				
			: ($event=On Row Moved:K2:32)
				
				C_LONGINT:C283($oldRowIdx;$newRowIdx)
				LISTBOX MOVED ROW NUMBER:C837(*;$propName;$oldRowIdx;$newRowIdx)
				If ($newRowIdx=1)
					  // Reject moves to 1st row (x-default)
					
					C_POINTER:C301($langCodesPtr;$langTitlesPtr;$langValuesPtr)
					$langCodesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_lang_code")
					$langTitlesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_lang_title")
					$langValuesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_value")
					
					LISTBOX INSERT ROWS:C913(*;$propName;$oldRowIdx+1)
					$langCodesPtr->{$oldRowIdx+1}:=$langCodesPtr->{1}
					$langTitlesPtr->{$oldRowIdx+1}:=$langTitlesPtr->{1}
					$langValuesPtr->{$oldRowIdx+1}:=$langValuesPtr->{1}
					
					LISTBOX DELETE ROWS:C914(*;$propName;1)
					
				Else 
					
					C_OBJECT:C1216($propSpec)
					$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
					
					LangAlt_Store ($paneContext;$propName;$propSpec)
					
					LangAlt_Load ($paneContext;$propName;$propSpec)
					
					EDIT ITEM:C870(*;$propName+"_lang_title";$newRowIdx)
					
				End if 
				
		End case 
		
End case 

