//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

ASSERT:C1129(OB Is defined:C1231($paneContext))

C_TEXT:C284($langCodeCol;$langTitleCol;$langValueCol)
$langCodeCol:=$propName+"_lang_code"
$langTitleCol:=$propName+"_lang_title"
$langValueCol:=$propName+"_value"

C_POINTER:C301($langCodeColPtr;$langTitleColPtr;$langValueColPtr)
$langCodeColPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$langCodeCol)
$langTitleColPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$langTitleCol)
$langValueColPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$langValueCol)

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($paneContext;"xmp_edit_data";Is text:K8:3)

XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)

ARRAY TEXT:C222($langCodes;0)
COPY ARRAY:C226($langCodeColPtr->;$langCodes)

ARRAY TEXT:C222($langValues;0)
COPY ARRAY:C226($langValueColPtr->;$langValues)

C_LONGINT:C283($langCount)
$langCount:=Size of array:C274($langCodes)

  // Remove empty elements
C_LONGINT:C283($idx)

For ($idx;$langCount;1;-1)
	If (($langCodes{$idx}="") | ($langValues{$idx}=""))
		DELETE FROM ARRAY:C228($langCodes;$idx)
		DELETE FROM ARRAY:C228($langValues;$idx)
		$langCount:=$langCount-1
	End if 
End for 

C_TEXT:C284($aLangCode;$alangValue)

If ($langCount>0)
	
	If ($langCount=1)
		
		If ($langCodes{1}="x-default")
			
			$alangValue:=$langValues{1}
			XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;"x-default";$alangValue)
			
		Else 
			
			$aLangCode:=$langCodes{1}
			$alangValue:=$langValues{1}
			
			XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;"x-default";$alangValue)
			XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;$aLangCode;$alangValue)
			
		End if 
		
	Else 
		
		If (False:C215)
			
			  // Get first non x-default
			$aLangCode:=""
			$alangValue:=""
			
			For ($idx;1;$langCount)
				If ($langCodes{$idx}#"x-default")
					$aLangCode:=$langCodes{$idx}
					$alangValue:=$langValues{$idx}
					$idx:=$langCount+1
				End if 
			End for 
			
		End if 
		
		C_LONGINT:C283($defaultIdx)
		$defaultIdx:=Find in array:C230($langCodes;"x-default")
		If ($defaultIdx>0)
			DELETE FROM ARRAY:C228($langCodes;$defaultIdx)
			DELETE FROM ARRAY:C228($langValues;$defaultIdx)
			$langCount:=$langCount-1
		End if 
		
		$alangValue:=$langValues{1}
		
		XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;"x-default";$alangValue)
		
		For ($idx;1;$langCount)
			
			$aLangCode:=$langCodes{$idx}
			$alangValue:=$langValues{$idx}
			
			XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;$aLangCode;$alangValue)
			
		End for 
		
	End if 
	
End if 

If (False:C215)
	
	C_BOOLEAN:C305($hasOnlyDefault)
	$hasOnlyDefault:=False:C215
	If ($langCount=1)
		If ($langCodeColPtr->{1}="x-default")
			$hasOnlyDefault:=True:C214
		End if 
	End if 
	
	If ($hasOnlyDefault)
		
		$aLangCode:="x-default"
		$alangValue:=$langValueColPtr->{1}
		
		If ($alangValue#"")
			XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;$aLangCode;$alangValue)
		End if 
		
	Else 
		
		For ($idx;1;$langCount)
			
			$aLangCode:=$langCodeColPtr->{$idx}
			If ($aLangCode#"x-default")
				$alangValue:=$langValueColPtr->{$idx}
				
				If ($alangValue#"")
					XMPData_SetLangAltPropValue:P11667:92 ($xmpDataRef;$propName;$aLangCode;$alangValue)
				End if 
				
			End if 
			
		End for 
		
	End if 
	
End if   // False

