//%attributes = {"invisible":true}
// =====================================
// Namespace prefixes dictionary
// =====================================

C_OBJECT:C1216(<>gXMPrefixes)
<>gXMPrefixes:=New object:C1471()

ARRAY TEXT:C222($nsURIs; 0)
OB GET PROPERTY NAMES:C1232(<>gXMPNamespaces; $nsURIs)

C_LONGINT:C283($nsCount; $idx)
$nsCount:=Size of array:C274($nsURIs)

For ($idx; 1; $nsCount)
	
	C_TEXT:C284($uri)
	$uri:=$nsURIs{$idx}
	
	C_OBJECT:C1216($nsInfo)
	$nsInfo:=OB Get:C1224(<>gXMPNamespaces; $uri; Is object:K8:27)
	
	If (OB Is defined:C1231($nsInfo; "Prefix"))
		
		C_TEXT:C284($nsPrefix)
		$nsPrefix:=OB Get:C1224($nsInfo; "Prefix"; Is text:K8:3)
		
		ASSERT:C1129(Not:C34(OB Is defined:C1231(<>gXMPrefixes; $nsPrefix)); \
			"Duplicate prefix "+String_Quoted($nsPrefix)+" for NS URI: "+$nsURIs{$idx})
		
		C_OBJECT:C1216($prefixInfo)
		$prefixInfo:=New object:C1471()
		
		If (OB Is defined:C1231($nsInfo; "Name"))
			OB SET:C1220($prefixInfo; "Name"; OB Get:C1224($nsInfo; "Name"; Is text:K8:3))
		End if 
		
		If (OB Is defined:C1231($nsInfo; "Desc"))
			OB SET:C1220($prefixInfo; "Desc"; OB Get:C1224($nsInfo; "Desc"; Is text:K8:3))
		End if 
		
		OB SET:C1220(<>gXMPrefixes; $nsPrefix; OB Copy:C1225($prefixInfo))
		
	End if 
	
End for 
