//%attributes = {"invisible":true}
// =====================================
// Property definition dictionaries
// =====================================

<>gXMPPropertiesFlat:=New object:C1471()
<>gXMPTypeAliases:=New object:C1471()

<>gXMPPropertiesByPrefix:=New object:C1471()
<>gXMPExtPropertiesByPrefix:=New object:C1471()

var $propFiles : Collection
$propFiles:=Lib_CollectResourceFiles("Q2Pix/Q2XMPLib/Properties"; ".json")

C_LONGINT:C283($ii; $jj)
For ($ii; 0; $propFiles.length-1)
	
	C_OBJECT:C1216($json)
	File_LoadJSON($propFiles[$ii]; ->$json)
	
	If (OB Is defined:C1231($json; "Properties"))
		
		C_OBJECT:C1216($specs)
		$specs:=OB Get:C1224($json; "Properties"; Is object:K8:27)
		
		ARRAY TEXT:C222($names; 0)
		OB GET PROPERTY NAMES:C1232($specs; $names)
		
		For ($jj; 1; Size of array:C274($names))
			
			C_TEXT:C284($aName)
			C_OBJECT:C1216($aSpec)
			
			$aName:=$names{$jj}
			$aSpec:=OB Get:C1224($specs; $aName; Is object:K8:27)
			
			Lib_SetupProperySpec($aName; $aSpec)
			
		End for 
		
	End if 
	
End for 

If (True:C214)
	
	ARRAY TEXT:C222($propNames; 0)
	OB GET PROPERTY NAMES:C1232(<>gXMPPropertiesFlat; $propNames)
	
	ARRAY TEXT:C222($aliasTypeNames; 0)
	OB GET PROPERTY NAMES:C1232(<>gXMPTypeAliases; $aliasTypeNames)
	
	ARRAY TEXT:C222($typeNames; 0)
	ARRAY TEXT:C222($elemTypeNames; 0)
	
	For ($ii; 1; Size of array:C274($propNames))
		
		C_OBJECT:C1216($spec)
		$spec:=OB Get:C1224(<>gXMPPropertiesFlat; $propNames{$ii}; Is object:K8:27)
		
		C_TEXT:C284($type)
		$type:=OB Get:C1224($spec; "Type"; Is text:K8:3)
		
		APPEND TO ARRAY:C911($typeNames; $type)
		
		If (($type="array") | ($type="bag"))
			
			If (Not:C34(OB Is defined:C1231($spec; "ElemType")))
				TRACE:C157
			Else 
			End if 
			
		Else 
			
			If (OB Is defined:C1231(<>gXMPTypeAliases; $type))
				
			End if 
			
		End if 
		
	End for 
	
End if 

