//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

C_BOOLEAN:C305($isEditable)
$isEditable:=Pane_IsPropertyEditable ($paneContext;$propName;$propSpec)

C_TEXT:C284($specType)
$specType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)

Case of 
	: ($specType="array")
		
		OBJECT DUPLICATE:C1111(*;"master_array";$propName)
		
	: ($specType="bag")
		
		OBJECT DUPLICATE:C1111(*;"master_bag";$propName)
		
	Else 
		TRACE:C157
End case 

If ($isEditable)
	OBJECT DUPLICATE:C1111(*;"master_seq_add";$propName+"_add")
	OBJECT DUPLICATE:C1111(*;"master_seq_del";$propName+"_del")
End if 

ARRAY TEXT:C222($listBoxObjects;0)
LISTBOX GET OBJECTS:C1302(*;$propName;$listBoxObjects)
C_TEXT:C284($templateCol)
$templateCol:=$listBoxObjects{1}

C_POINTER:C301($nilPtr)

C_TEXT:C284($valueColName;$backupColName)
$valueColName:=$propName+"_value"
$backupColName:=$propName+"_backup"

LISTBOX DUPLICATE COLUMN:C1273(*;$templateCol;1;$valueColName;$nilPtr;$valueColName+"_header";$nilPtr)
LISTBOX DUPLICATE COLUMN:C1273(*;$templateCol;2;$backupColName;$nilPtr;$backupColName+"_header";$nilPtr)

LISTBOX DELETE COLUMN:C830(*;$propName;3;1)

OBJECT SET VISIBLE:C603(*;$backupColName;False:C215)

If ($isEditable)
	OBJECT SET ENTERABLE:C238(*;$valueColName;True:C214)
	OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
End if 

  // =======================================
  // Load data

Seq_Load ($paneContext;$propName;$propSpec)

