//%attributes = {"invisible":true}

C_OBJECT:C1216($layoutInfo)

ARRAY TEXT:C222($formObjects;0)
FORM GET OBJECTS:C898($formObjects;1)

ARRAY TEXT:C222($propNames;0)

C_LONGINT:C283($idx)

For ($idx;1;Size of array:C274($formObjects))
	
	C_TEXT:C284($objName)
	$objName:=$formObjects{$idx}
	If ($objName="label_@")
		APPEND TO ARRAY:C911($propNames;Substring:C12($objName;Length:C16("label_")+1))
	End if 
	
End for 

C_LONGINT:C283($propCount)
$propCount:=Size of array:C274($propNames)

  // =======================================
  // Spacing

C_LONGINT:C283($horzMargin;$vertMargin)
$horzMargin:=10
$vertMargin:=10

  // =======================================
  // Get space

C_LONGINT:C283($containerWidth;$containerHeight)
OBJECT GET SUBFORM CONTAINER SIZE:C1148($containerWidth;$containerHeight)

  // =======================================
  // Calculate max label width

C_LONGINT:C283($maxLabelWidth)
$maxLabelWidth:=0

For ($idx;1;$propCount)
	
	C_TEXT:C284($name)
	$name:=$propNames{$idx}
	
	$entryType:=OBJECT Get type:C1300(*;$name)
	If ($entryType#Object type unknown:K79:1)
		
		C_LONGINT:C283($labelWidth;$labelHeight)
		OBJECT GET BEST SIZE:C717(*;"label_"+$name;$labelWidth;$labelHeight)
		
		If ($labelWidth>$maxLabelWidth)
			$maxLabelWidth:=$labelWidth
		End if 
		
	End if 
	
End for 

  // =======================================
  // Label and value entry space.

C_LONGINT:C283($horzLabelSpace;$horzValueSpace)

$horzLabelSpace:=($containerWidth-(3*$horzMargin))/3
If ($horzLabelSpace>$maxLabelWidth)
	$horzLabelSpace:=$maxLabelWidth
End if 
$horzValueSpace:=$containerWidth-(3*$horzMargin)-$horzLabelSpace

  // =======================================
  // Calculate label and value entry heights,
  // and total sizer height

C_LONGINT:C283($sectionCount;$sectionHeightSum)
$sectionCount:=0
$sectionHeightSum:=0

For ($idx;1;$propCount)
	
	C_TEXT:C284($name)
	$name:=$propNames{$idx}
	
	C_LONGINT:C283($entryType)
	$entryType:=OBJECT Get type:C1300(*;$name)
	If ($entryType#Object type unknown:K79:1)
		
		C_LONGINT:C283($labelWidth;$labelHeight)
		OBJECT GET BEST SIZE:C717(*;"label_"+$name;$labelWidth;$labelHeight;$horzLabelSpace)
		
		C_LONGINT:C283($valueWidth;$valueHeight)
		
		Case of 
			: ($entryType=Object type text input:K79:4)
				
				OBJECT GET BEST SIZE:C717(*;$name;$valueWidth;$valueHeight;$horzValueSpace)
				
			: ($entryType=Object type listbox:K79:8)
				
				If (OBJECT Get type:C1300(*;$name+"_add")#Object type unknown:K79:1)  // Has add/del buttons
					$valueHeight:=FormObj_GetHeight ($name)+10+FormObj_GetHeight ($name+"_add")
				Else 
					$valueHeight:=FormObj_GetHeight ($name)
				End if 
				
			Else 
				
				$valueHeight:=FormObj_GetHeight ($name)
				
		End case 
		
		C_LONGINT:C283($sectionHeight)
		$sectionHeight:=$valueHeight
		If ($labelHeight>$sectionHeight)
			$sectionHeight:=$labelHeight
		End if 
		
		C_OBJECT:C1216($propInfo)
		OB SET:C1220($propInfo;"label_height";$labelHeight)
		OB SET:C1220($propInfo;"value_height";$valueHeight)
		OB SET:C1220($propInfo;"section_height";$sectionHeight)
		OB SET:C1220($layoutInfo;$name;OB Copy:C1225($propInfo))
		
		$sectionCount:=$sectionCount+1
		$sectionHeightSum:=$sectionHeightSum+$sectionHeight
		
	End if 
	
End for 

  // =======================================
  // Set sizer to some large value in order
  // to make room for labels and data.

OBJECT SET COORDINATES:C1248(*;"sizer";0;0;8000;8000)

  // =======================================
  // Layout objects

C_LONGINT:C283($curTop)
$curTop:=$vertMargin

For ($idx;1;$propCount)
	
	C_TEXT:C284($name)
	$name:=$propNames{$idx}
	
	C_OBJECT:C1216($propInfo)
	$propInfo:=OB Get:C1224($layoutInfo;$name;Is object:K8:27)
	
	C_LONGINT:C283($entryType)
	$entryType:=OBJECT Get type:C1300(*;$name)
	If ($entryType#Object type unknown:K79:1)
		
		$labelHeight:=OB Get:C1224($propInfo;"label_height";Is longint:K8:6)
		$valueHeight:=OB Get:C1224($propInfo;"value_height";Is longint:K8:6)
		$sectionHeight:=OB Get:C1224($propInfo;"section_height";Is longint:K8:6)
		
		C_LONGINT:C283($labelLeft)
		$labelLeft:=$horzMargin
		
		OBJECT SET COORDINATES:C1248(*;"label_"+$name;$labelLeft;$curTop;\
			$labelLeft+$horzLabelSpace;$curTop+$labelHeight)
		
		OBJECT SET VISIBLE:C603(*;"label_"+$name;True:C214)
		
		C_LONGINT:C283($valueLeft)
		$valueLeft:=$horzMargin+$horzLabelSpace+$horzMargin
		
		Case of 
			: ($entryType=Object type text input:K79:4)
				
				OBJECT SET COORDINATES:C1248(*;$name;$valueLeft;$curTop;\
					$valueLeft+$horzValueSpace;$curTop+$valueHeight)
				
				OBJECT SET VISIBLE:C603(*;$name;True:C214)
				
			: ($entryType=Object type listbox:K79:8)
				
				If (OBJECT Get type:C1300(*;$name+"_add")#Object type unknown:K79:1)  // Has add/del buttons
					
					C_OBJECT:C1216($addButtonSize)
					$addButtonSize:=FormObj_GetSize ($name+"_add")
					
					C_OBJECT:C1216($delButtonSize)
					$delButtonSize:=FormObj_GetSize ($name+"_del")
					
					C_LONGINT:C283($listboxHeight)
					$listboxHeight:=$valueHeight-10-SizeObj_GetHeight ($addButtonSize)
					
					C_OBJECT:C1216($valueRect)
					$valueRect:=RectObj_New ($valueLeft;$curTop;$horzValueSpace;$listboxHeight)
					FormObj_SetRect ($name;$valueRect)
					
					C_OBJECT:C1216($addButtonRect)
					$addButtonRect:=RectObj_New ($valueLeft;$curTop+$listboxHeight+10;\
						SizeObj_GetWidth ($addButtonSize);SizeObj_GetHeight ($addButtonSize))
					FormObj_SetRect ($name+"_add";$addButtonRect)
					
					C_OBJECT:C1216($delButtonRect)
					$delButtonRect:=RectObj_New ($valueLeft+SizeObj_GetWidth ($addButtonSize)+10;\
						$curTop+$listboxHeight+10;\
						SizeObj_GetWidth ($delButtonSize);\
						SizeObj_GetHeight ($addButtonSize))
					FormObj_SetRect ($name+"_del";$delButtonRect)
					
					OBJECT SET VISIBLE:C603(*;$name;True:C214)
					OBJECT SET VISIBLE:C603(*;$name+"_add";True:C214)
					OBJECT SET VISIBLE:C603(*;$name+"_del";True:C214)
					
				Else 
					
					OBJECT SET COORDINATES:C1248(*;$name;$valueLeft;$curTop;\
						$valueLeft+$horzValueSpace;$curTop+$valueHeight)
					
					OBJECT SET VISIBLE:C603(*;$name;True:C214)
					
				End if 
				
			Else 
				
				OBJECT SET COORDINATES:C1248(*;$name;$valueLeft;$curTop;\
					$valueLeft+$horzValueSpace;$curTop+$valueHeight)
				
				OBJECT SET VISIBLE:C603(*;$name;True:C214)
				
		End case 
		
		
		$curTop:=$curTop+$sectionHeight+$vertMargin
		
	End if 
	
End for 

  // =======================================
  // Update sizer

C_LONGINT:C283($sizerHeight)
$sizerHeight:=$sectionHeightSum+(($sectionCount+1)*$vertMargin)

OBJECT SET COORDINATES:C1248(*;"sizer";0;0;$containerWidth;$sizerHeight)

