//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

ASSERT:C1129(OB Is defined:C1231($paneContext))
ASSERT:C1129(OB Is defined:C1231($propSpec))

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($paneContext;"xmp_edit_data";Is text:K8:3)

C_TEXT:C284($propValue)
$propValue:=XMPData_GetSimplePropertyValue:P11667:84 ($xmpDataRef;$propName)

C_LONGINT:C283($controlType)
$controlType:=OBJECT Get type:C1300(*;$propName)

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName)

Case of 
	: ($controlType=Object type text input:K79:4)
		
		C_TEXT:C284($displayValue)
		$displayValue:=Prop_GetDisplayValue ($propValue;$propSpec)
		
		$controlPtr->:=$displayValue
		
	: ($controlType=Object type popup dropdown list:K79:13)
		
		If ($propValue="")
			
			  // Select last element "(none)"
			$controlPtr->:=Size of array:C274($controlPtr->)
			
		Else 
			
			Case of 
				: (OB Get type:C1230($propSpec;"Choices")=Is object:K8:27)
					
					ARRAY TEXT:C222($choiceValues;0)
					ARRAY TEXT:C222($choiceKeys;0)
					Spec_GetChoices ($propSpec;->$choiceValues;->$choiceKeys)
					
					$controlPtr->:=Find in array:C230($choiceKeys;$propValue)
					
				: (OB Get type:C1230($propSpec;"Choices")=Object array:K8:28)
					
					ARRAY TEXT:C222($choiceValues;0)
					Spec_GetChoices ($propSpec;->$choiceValues)
					
					$controlPtr->:=Find in array:C230($choiceValues;$propValue)
					
			End case 
			
		End if 
		
	: ($controlType=Object type combobox:K79:12)
		
		$controlPtr->{0}:=$propValue
		
End case 

