//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$specsObject)
$specsObject:=$1

ARRAY TEXT:C222($propNames;0)
OB GET PROPERTY NAMES:C1232($specsObject;$propNames)

C_LONGINT:C283($idx)

For ($idx;1;Size of array:C274($propNames))
	
	C_TEXT:C284($name)
	$name:=$propNames{$idx}
	
	C_OBJECT:C1216($spec)
	$spec:=OB Get:C1224($specsObject;$name;Is object:K8:27)
	
	If (Position:C15(":";$name)>0)
		
		C_TEXT:C284($type)
		$type:=OB Get:C1224($spec;"Type";Is text:K8:3)
		
		If ($type="")
			ALERT:C41("Missing element type for property "+String_Quoted ($name)+".")
		Else 
			
			If (($type="array") | ($type="bag"))
				
				C_TEXT:C284($elemType)
				
				$elemType:=OB Get:C1224($spec;"ElemType";Is text:K8:3)
				
				If ($elemType="")
					ALERT:C41("Missing element type for property \""+$name+"\".")
				Else 
					If (Not:C34(_XMP_Validate_Spec_Type ($elemType)))
						
						ALERT:C41("Unknown array or bag element type "\
							+String_Quoted ($elemType)\
							+" for property "+String_Quoted ($name)+".")
						
					End if 
				End if 
				
			Else 
				
				If (Not:C34(_XMP_Validate_Spec_Type ($type)))
					ALERT:C41("Unknown property type "\
						+String_Quoted ($type)\
						+" for property "+String_Quoted ($name)+".")
				End if 
				
			End if 
			
		End if 
		
		
	Else 
		
		_XMP_Validate_Specs_Object ($spec)
		
	End if 
	
	
End for 

