C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Load:K2:1)
		
		C_POINTER:C301($archivePathPtr)
		$archivePathPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "archive_path")
		$archivePathPtr->:=FSRef_GetPOSIXPath(gArchiveDirFSRef)
		
		OBJECT SET ENABLED:C1123(*; "image_info"; False:C215)
		OBJECT SET ENABLED:C1123(*; "image_viewer"; False:C215)
		OBJECT SET ENABLED:C1123(*; "image_record"; False:C215)
		OBJECT SET ENABLED:C1123(*; "image_xmp"; False:C215)
		
		C_TEXT:C284($imageResourcesFolder)
		$imageResourcesFolder:=Get 4D folder:C485(Current resources folder:K5:16)+"Images"+Folder separator:K24:12
		
		C_BOOLEAN:C305(gArchiveBrowserXMPDevMode)
		gArchiveBrowserXMPDevMode:=False:C215
		
		C_PICTURE:C286(gArchiveFolderPict; gArchiveFilePict)
		READ PICTURE FILE:C678($imageResourcesFolder+"folder.png"; gArchiveFolderPict)
		READ PICTURE FILE:C678($imageResourcesFolder+"file.png"; gArchiveFilePict)
		
		C_LONGINT:C283(gArchiveList)
		gArchiveList:=New list:C375
		
		C_TEXT:C284($rootItemPath)
		$rootItemPath:=FSRef_GetPOSIXPath(gArchiveDirFSRef)
		
		C_TEXT:C284($rootItemTitle)
		$rootItemTitle:=FSRef_GetName(gArchiveDirFSRef)
		
		C_LONGINT:C283($rootItemRef)
		$rootItemRef:=1
		
		C_LONGINT:C283($rootItemList)
		$rootItemList:=New list:C375
		
		APPEND TO LIST:C376(gArchiveList; $rootItemTitle; $rootItemRef; $rootItemList; True:C214)
		SET LIST ITEM ICON:C950(gArchiveList; $rootItemRef; gArchiveFolderPict)
		SET LIST ITEM PARAMETER:C986(gArchiveList; $rootItemRef; "Path"; $rootItemPath)
		SET LIST ITEM PARAMETER:C986(gArchiveList; $rootItemRef; "Seed"; 2)
		
		ArchiveList_PopulateDirItem(gArchiveList; $rootItemRef)
		
		
	: ($event=On Unload:K2:2)
		
		If ((gArchiveList#0) & Is a list:C621(gArchiveList))
			CLEAR LIST:C377(gArchiveList; *)
			gArchiveList:=0
		End if 
		
	: ($event=On Outside Call:K2:11)
		
		ARRAY OBJECT:C1221($messageQueue; 0)
		ArchiveBrowser_GetMessages(->$messageQueue)
		
		C_LONGINT:C283($idx; $msgCount)
		$msgCount:=Size of array:C274($messageQueue)
		For ($idx; 1; $msgCount)
			
			C_OBJECT:C1216($message)
			$message:=$messageQueue{$idx}
			
			C_TEXT:C284($what)
			$what:=OB Get:C1224($message; "What"; Is text:K8:3)
			
			C_TEXT:C284($path)
			$path:=OB Get:C1224($message; "Path"; Is text:K8:3)
			
			Case of 
				: ($what="Refresh")
					
					C_LONGINT:C283($targetItem)
					$targetItem:=ArchiveList_FindItemWithPath(gArchiveList; $path)
					If ($targetItem#0)
						
						ArchiveList_PopulateDirItem(gArchiveList; $targetItem)
						
					End if 
					
				: ($what="Select")
					
			End case 
			
		End for 
		
End case 
