C_LONGINT:C283($0)
$0:=0

C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Double Clicked:K2:5)
		
		C_POINTER:C301($fileListPtr)
		$fileListPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_files")
		
		C_LONGINT:C283($selectedCount)
		$selectedCount:=Count in array:C907($fileListPtr->; True:C214)
		If ($selectedCount=1)
			
			C_POINTER:C301($srcPathPtr)
			$srcPathPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_path")
			
			C_TEXT:C284($itemPath)
			$itemPath:=$srcPathPtr->{$fileListPtr->}
			
			C_OBJECT:C1216($args)
			OB SET:C1220($args; "Path"; $itemPath)
			
			ImgControl_Viewer("open"; $args)
			
		End if 
		
	: ($event=On Selection Change:K2:29)
		
		C_POINTER:C301($fileListPtr)
		$fileListPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_files")
		
		OBJECT SET ENABLED:C1123(*; "remove"; Find in array:C230($fileListPtr->; True:C214)>0)
		
	: ($event=On Delete Action:K2:56)
		
		ImageMerger("remove")
		
	: ($event=On Begin Drag Over:K2:44)
		
		C_POINTER:C301($fileListPtr)
		$fileListPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_files")
		
		ARRAY LONGINT:C221($selectedRows; 0)
		
		C_LONGINT:C283($idx)
		For ($idx; 1; Size of array:C274($fileListPtr->))
			If ($fileListPtr->{$idx})
				APPEND TO ARRAY:C911($selectedRows; $idx)
			End if 
		End for 
		
		C_OBJECT:C1216($dragInfo)
		OB SET ARRAY:C1227($dragInfo; "ImageRows"; $selectedRows)
		
		C_TEXT:C284($dragJSON)
		$dragJSON:=JSON Stringify:C1217($dragInfo; *)
		
		C_BLOB:C604($dragData)
		TEXT TO BLOB:C554($dragJSON; $dragData; UTF8 text without length:K22:17)
		APPEND DATA TO PASTEBOARD:C403("demo.rows"; $dragData)
		
	: (($event=On Drag Over:K2:13) | ($event=On Drop:K2:12))
		
		C_BLOB:C604($dragData)
		GET PASTEBOARD DATA:C401("demo.paths"; $dragData)
		
		If (BLOB size:C605($dragData)>0)
			
			If ($event=On Drop:K2:12)
				
				C_LONGINT:C283($dropPos)
				$dropPos:=Drop position:C608
				
				C_TEXT:C284($dragJSON)
				$dragJSON:=BLOB to text:C555($dragData; UTF8 text without length:K22:17)
				
				C_OBJECT:C1216($dragInfo)
				$dragInfo:=JSON Parse:C1218($dragJSON; Is object:K8:27)
				OB SET:C1220($dragInfo; "DropPos"; $dropPos)
				
				ImageMerger("_add"; $dragInfo)
				
			End if 
			
		Else 
			
			GET PASTEBOARD DATA:C401("demo.rows"; $dragData)
			
			If (BLOB size:C605($dragData)>0)
				
				If ($event=On Drop:K2:12)
					
					C_POINTER:C301($srcThumbPtr; $srcNamePtr; $srcCountPtr; $srcKindPtr; $srcPathPtr)
					$srcThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_thumb")
					$srcNamePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_name")
					$srcCountPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_count")
					$srcKindPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_kind")
					$srcPathPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "src_path")
					
					C_LONGINT:C283($dropPos)
					$dropPos:=Drop position:C608
					
					If ($dropPos=-1)
						$dropPos:=Size of array:C274($srcThumbPtr->)+1
					End if 
					
					C_TEXT:C284($dragJSON)
					$dragJSON:=BLOB to text:C555($dragData; UTF8 text without length:K22:17)
					
					C_OBJECT:C1216($dragInfo)
					$dragInfo:=JSON Parse:C1218($dragJSON; Is object:K8:27)
					
					ARRAY LONGINT:C221($selectedRows; 0)
					OB GET ARRAY:C1229($dragInfo; "ImageRows"; $selectedRows)
					
					C_LONGINT:C283($selectedRowCount)
					$selectedRowCount:=Size of array:C274($selectedRows)
					
					ARRAY PICTURE:C279($selectedThumbs; $selectedRowCount)
					ARRAY TEXT:C222($selectedNames; $selectedRowCount)
					ARRAY LONGINT:C221($selectedFrames; $selectedRowCount)
					ARRAY TEXT:C222($selectedKinds; $selectedRowCount)
					ARRAY TEXT:C222($selectedPaths; $selectedRowCount)
					
					C_LONGINT:C283($origInsertionPoint)
					$origInsertionPoint:=$dropPos
					
					C_LONGINT:C283($preInsertionPointCount)
					$preInsertionPointCount:=0
					
					C_LONGINT:C283($ii)
					
					For ($ii; $selectedRowCount; 1; -1)
						
						$selectedThumbs{$ii}:=$srcThumbPtr->{$selectedRows{$ii}}
						$selectedNames{$ii}:=$srcNamePtr->{$selectedRows{$ii}}
						$selectedFrames{$ii}:=$srcCountPtr->{$selectedRows{$ii}}
						$selectedKinds{$ii}:=$srcKindPtr->{$selectedRows{$ii}}
						$selectedPaths{$ii}:=$srcPathPtr->{$selectedRows{$ii}}
						
						// Count hilited items that were before the original insertion point
						// to calculate the modified insertion point
						If ($selectedRows{$ii}<$origInsertionPoint)
							$preInsertionPointCount:=$preInsertionPointCount+1
						End if 
						
						DELETE FROM ARRAY:C228($srcThumbPtr->; $selectedRows{$ii})
						DELETE FROM ARRAY:C228($srcNamePtr->; $selectedRows{$ii})
						DELETE FROM ARRAY:C228($srcCountPtr->; $selectedRows{$ii})
						DELETE FROM ARRAY:C228($srcKindPtr->; $selectedRows{$ii})
						DELETE FROM ARRAY:C228($srcPathPtr->; $selectedRows{$ii})
						
					End for 
					
					C_LONGINT:C283($newInsertionPoint)
					$newInsertionPoint:=$origInsertionPoint-$preInsertionPointCount
					
					LISTBOX SELECT ROW:C912(*; "src_files"; 0; 2)
					
					For ($ii; 1; $selectedRowCount)
						
						C_LONGINT:C283($newRowIndex)
						$newRowIndex:=$newInsertionPoint+$ii-1
						
						// Insert dropped cells at new insertion point  
						INSERT IN ARRAY:C227($srcThumbPtr->; $newRowIndex; 1)
						INSERT IN ARRAY:C227($srcNamePtr->; $newRowIndex; 1)
						INSERT IN ARRAY:C227($srcCountPtr->; $newRowIndex; 1)
						INSERT IN ARRAY:C227($srcKindPtr->; $newRowIndex; 1)
						INSERT IN ARRAY:C227($srcPathPtr->; $newRowIndex; 1)
						
						$srcThumbPtr->{$newRowIndex}:=$selectedThumbs{$ii}
						$srcNamePtr->{$newRowIndex}:=$selectedNames{$ii}
						$srcCountPtr->{$newRowIndex}:=$selectedFrames{$ii}
						$srcKindPtr->{$newRowIndex}:=$selectedKinds{$ii}
						$srcPathPtr->{$newRowIndex}:=$selectedPaths{$ii}
						
						LISTBOX SELECT ROW:C912(*; "src_files"; $newRowIndex; 1)
						
					End for 
					
				End if 
				
			Else 
				
				$0:=-1
				
			End if 
			
		End if 
		
End case 
