//%attributes = {}

C_PICTURE:C286($nullPict)
C_POINTER:C301($imageThumbPtr)
$imageThumbPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "image_thumb")
$imageThumbPtr->:=$nullPict

C_POINTER:C301($imageDesPtr)
$imageDesPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "image_desc")
$imageDesPtr->:=""

OBJECT SET ENABLED:C1123(*; "image_info"; False:C215)
OBJECT SET ENABLED:C1123(*; "image_viewer"; False:C215)
OBJECT SET ENABLED:C1123(*; "image_record"; False:C215)
OBJECT SET ENABLED:C1123(*; "image_xmp"; False:C215)
OBJECT SET ENABLED:C1123(*; "image_merge"; False:C215)

OBJECT SET VISIBLE:C603(*; "frame_prev"; False:C215)
OBJECT SET VISIBLE:C603(*; "frame_next"; False:C215)

C_LONGINT:C283($currentItemRef)
ARRAY LONGINT:C221($selectedItemRefs; 0)

$currentItemRef:=Selected list items:C379(gArchiveList; $selectedItemRefs; *)

Case of 
	: (Size of array:C274($selectedItemRefs)=1)
		
		C_TEXT:C284($itemPath)
		GET LIST ITEM PARAMETER:C985(gArchiveList; $currentItemRef; "Path"; $itemPath)
		
		C_OBJECT:C1216($itemFSRef)
		$itemFSRef:=FSRef_InitWithPOSIXPath($itemPath)
		
		If (FSRef_IsFile($itemFSRef))
			
			C_TEXT:C284($imgDocRef)
			$imgDocRef:=ImgDoc_CreateWithFile($itemPath)
			If ($imgDocRef#"")
				
				C_TEXT:C284($format)
				$format:=ImgDoc_GetFormat:P11667:9($imgDocRef)
				
				C_OBJECT:C1216($formatInfo)
				$formatInfo:=ImgFormat_GetInfo($format)
				
				C_TEXT:C284($formatName)
				$formatName:=OB Get:C1224($formatInfo; "Name"; Is text:K8:3)
				
				C_BOOLEAN:C305($isRaster)
				$isRaster:=OB Get:C1224($formatInfo; "IsRaster"; Is boolean:K8:9)
				
				C_LONGINT:C283($frameCount)
				$frameCount:=ImgDoc_GetFrameCount:P11667:11($imgDocRef)
				
				C_LONGINT:C283($frameIdx)
				GET LIST ITEM PARAMETER:C985(gArchiveList; $currentItemRef; "Frame"; $frameIdx)
				
				If (($frameIdx>0) & ($frameIdx<=$frameCount))
				Else 
					$frameIdx:=1
				End if 
				
				SET LIST ITEM PARAMETER:C986(gArchiveList; $currentItemRef; "Frame"; $frameIdx)
				
				If ($frameCount>1)
					If ($isRaster)
						$imageDesPtr->:=$format+" frame "+String:C10($frameIdx)+"/"+String:C10($frameCount)
					Else 
						$imageDesPtr->:=$format+" page "+String:C10($frameIdx)+"/"+String:C10($frameCount)
					End if 
				Else 
					$imageDesPtr->:=$formatName
				End if 
				
				C_PICTURE:C286($thumb)
				If ($isRaster)
					$thumb:=RasterFrame_GetEmbThumbPict($imgDocRef; $frameIdx)
				End if 
				If (Picture size:C356($thumb)=0)
					$thumb:=ImgFrame_CreateThumbPict($imgDocRef; $frameIdx)
				End if 
				$imageThumbPtr->:=$thumb
				
				OBJECT SET ENABLED:C1123(*; "image_info"; True:C214)
				OBJECT SET ENABLED:C1123(*; "image_viewer"; True:C214)
				OBJECT SET ENABLED:C1123(*; "image_xmp"; True:C214)
				OBJECT SET ENABLED:C1123(*; "image_merge"; True:C214)
				
				C_TEXT:C284($recordsDirPrefix)
				$recordsDirPrefix:=FSRef_GetPOSIXPath(gArchiveDirFSRef)+"/_Imports/"
				If (Substring:C12($itemPath; 1; Length:C16($recordsDirPrefix))#$recordsDirPrefix)
					OBJECT SET ENABLED:C1123(*; "image_record"; True:C214)
				End if 
				
				If ($frameCount>1)
					
					OBJECT SET VISIBLE:C603(*; "frame_prev"; True:C214)
					OBJECT SET VISIBLE:C603(*; "frame_next"; True:C214)
					
					OBJECT SET ENABLED:C1123(*; "frame_prev"; ($frameIdx>1))
					OBJECT SET ENABLED:C1123(*; "frame_next"; ($frameIdx<$frameCount))
					
				End if 
				
				ImgObj_Release:P11667:133($imgDocRef)
				
			End if 
			
		End if 
		
	: (Size of array:C274($selectedItemRefs)>1)
		
		C_BOOLEAN:C305($canMerge)
		$canMerge:=False:C215
		
		C_LONGINT:C283($idx)
		For ($idx; 1; Size of array:C274($selectedItemRefs))
			
			C_TEXT:C284($itemPath)
			GET LIST ITEM PARAMETER:C985(gArchiveList; $selectedItemRefs{$idx}; "Path"; $itemPath)
			
			C_OBJECT:C1216($itemFSRef)
			$itemFSRef:=FSRef_InitWithPOSIXPath($itemPath)
			
			If (Not:C34(FSRef_IsFile($itemFSRef)))
				$canMerge:=False:C215
				$idx:=Size of array:C274($selectedItemRefs)+1
			End if 
			
		End for 
		
		OBJECT SET ENABLED:C1123(*; "image_merge"; $canMerge)
		
End case 


