//%attributes = {}
C_LONGINT:C283($1; $listRef)
C_LONGINT:C283($2; $itemRef)

$listRef:=$1
$itemRef:=$2

C_LONGINT:C283($itemListRef)
C_TEXT:C284($itemTitle)
GET LIST ITEM:C378($listRef; List item position:C629($listRef; $itemRef); $itemRef; $itemTitle; $itemListRef)
If ($itemListRef#0)
	
	// Delete existing items
	While (Count list items:C380($itemListRef)>0)
		C_LONGINT:C283($tempItemID)
		C_TEXT:C284($tempItemTitle)
		GET LIST ITEM:C378($itemListRef; 1; $tempItemID; $tempItemTitle)
		DELETE FROM LIST:C624($itemListRef; $tempItemID; *)
	End while 
	
	
	C_TEXT:C284($itemPath)
	$itemPath:=ArchiveList_GetItemPath($listRef; $itemRef)
	
	C_OBJECT:C1216($itemFSRef)
	$itemFSRef:=FSRef_InitWithPOSIXPath($itemPath)
	
	// ==================================
	// Append directories
	
	C_OBJECT:C1216($dirListOptions)
	OB SET:C1220($dirListOptions; "includeDirs"; True:C214; "includeFiles"; False:C215)
	
	ARRAY TEXT:C222($dirPaths; 0)
	FSRef_GetDirItems($itemFSRef; ->$dirPaths; $dirListOptions)
	SORT ARRAY:C229($dirPaths)
	
	C_LONGINT:C283($idx)
	For ($idx; 1; Size of array:C274($dirPaths))
		
		C_TEXT:C284($newItemTitle)
		$newItemTitle:=FSRef_GetName(FSRef_InitWithPOSIXPath($dirPaths{$idx}))
		
		C_LONGINT:C283($newItemRef)
		GET LIST ITEM PARAMETER:C985($listRef; 1; "Seed"; $newItemRef)
		SET LIST ITEM PARAMETER:C986($listRef; 1; "Seed"; $newItemRef+1)
		
		C_LONGINT:C283($newItemList)
		$newItemList:=New list:C375
		//APPEND TO LIST($newItemList;"Dummy item";-$newItemRef)
		
		APPEND TO LIST:C376($itemListRef; $newItemTitle; $newItemRef; $newItemList; False:C215)
		SET LIST ITEM PARAMETER:C986($itemListRef; $newItemRef; "Path"; $dirPaths{$idx})
		SET LIST ITEM ICON:C950($itemListRef; $newItemRef; gArchiveFolderPict)
		
		ArchiveList_PopulateDirItem($listRef; $newItemRef)
		
	End for 
	
	// ==================================
	// Append Image files
	
	C_OBJECT:C1216($extensionMap)
	$extensionMap:=ImgFormat_GetExtensionMap
	
	C_OBJECT:C1216($fileListOptions)
	OB SET:C1220($fileListOptions; "includeDirs"; False:C215; "includeFiles"; True:C214)
	
	ARRAY TEXT:C222($filePaths; 0)
	FSRef_GetDirItems($itemFSRef; ->$filePaths; $fileListOptions)
	SORT ARRAY:C229($filePaths)
	
	For ($idx; 1; Size of array:C274($filePaths))
		
		C_OBJECT:C1216($fileRef)
		$fileRef:=FSRef_InitWithPOSIXPath($filePaths{$idx})
		
		C_TEXT:C284($fileExtension)
		$fileExtension:=FSRef_GetExtension($fileRef)
		
		If (OB Is defined:C1231($extensionMap; $fileExtension))
			
			C_TEXT:C284($fileName)
			$fileName:=FSRef_GetName($fileRef)
			
			C_LONGINT:C283($newItemRef)
			GET LIST ITEM PARAMETER:C985($listRef; 1; "Seed"; $newItemRef)
			SET LIST ITEM PARAMETER:C986($listRef; 1; "Seed"; $newItemRef+1)
			
			APPEND TO LIST:C376($itemListRef; $fileName; $newItemRef)
			SET LIST ITEM PARAMETER:C986($itemListRef; $newItemRef; "Path"; $filePaths{$idx})
			SET LIST ITEM ICON:C950($itemListRef; $newItemRef; gArchiveFilePict)
			
		End if 
		
	End for 
	
	//If (Count list items($itemListRef)=0)
	//APPEND TO LIST($itemListRef;"Empty";-$itemRef)
	//SET LIST ITEM PROPERTIES($itemListRef;-$itemRef;False;Italic;0)
	//End if 
	
End if 
