//%attributes = {}
C_TEXT:C284($1; $archiveDirPath)
C_TEXT:C284($2; $imagePath)
C_TEXT:C284($0; $destImagePath)

$archiveDirPath:=$1
$imagePath:=$2
$destImagePath:=""

C_OBJECT:C1216($destDirFSRef)
$destDirFSRef:=FSRef_InitWithPOSIXPath($archiveDirPath)

C_OBJECT:C1216($imageFSRef)
$imageFSRef:=FSRef_InitWithPOSIXPath($imagePath)

C_TEXT:C284($imageFileName)
$imageFileName:=FSRef_GetName($imageFSRef)

C_TEXT:C284($imageBaseName)
$imageBaseName:=FSRef_GetName(FSRef_SetExtension($imageFSRef; ""))

C_TEXT:C284($imageExtension)
$imageExtension:=FSRef_GetExtension($imageFSRef)

C_OBJECT:C1216($destImageFSRef)
$destImageFSRef:=FSRef_AppendName($destDirFSRef; $imageFileName)

C_TEXT:C284($destFileName)
$destFileName:=""

C_LONGINT:C283($idx)
$idx:=0

While (FSRef_Exists($destImageFSRef))
	$idx:=$idx+1
	$destFileName:=$imageBaseName+"-"+String:C10($idx)+"."+$imageExtension
	$destImageFSRef:=FSRef_AppendName($destDirFSRef; $destFileName)
End while 

C_TEXT:C284($sourceSystemPath; $destSystemPath)
$sourceSystemPath:=Convert path POSIX to system:C1107($imagePath)
$destSystemPath:=FSRef_GetSystemPath($destImageFSRef)

COPY DOCUMENT:C541($sourceSystemPath; $destSystemPath)
If (OK=1)
	$destImagePath:=FSRef_GetPOSIXPath($destImageFSRef)
	
	C_OBJECT:C1216($message)
	OB SET:C1220($message; "What"; "Refresh"; "Path"; $archiveDirPath)
	ArchiveBrowser_PostMessage($message)
	
End if 

$0:=$destImagePath
