C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Load:K2:1)
		
		gRecordViewImageID:=0  // Reset
		
		C_TEXT:C284($windowTitle)
		$windowTitle:="Image ID "+String:C10([Image:1]ID:1)
		If ([Image:1]Name:2#"")
			$windowTitle:=$windowTitle+" ("+[Image:1]Name:2+")"
		End if 
		SET WINDOW TITLE:C213($windowTitle)
		
		If (ImgControl_Initialize("img_control"; "img_area")=1)
			ImgControl_SetupWithConfig("img_control"; "Record Viewer")
			
			Case of 
				: ([Image:1]Path:3#"")
					
					C_OBJECT:C1216($imageFSRef)
					$imageFSRef:=FSRef_InitWithPOSIXPath([Image:1]Path:3)
					If (Not:C34(OB Is defined:C1231($imageFSRef)))
						$imageFSRef:=FSRef_AppendSubPath(FSRef_InitWithPOSIXPath(Archive_GetDirPath); [Image:1]Path:3)
					End if 
					
					If (FSRef_IsFile($imageFSRef))
						
						ImgControl_SetImageFile("img_control"; FSRef_GetPOSIXPath($imageFSRef))
						
					End if 
					
				: (BLOB size:C605([Image:1]Data:4)>0)
					
					ImgControl_SetImageBLOB("img_control"; ->[Image:1]Data:4)
					
				: (Picture size:C356([Image:1]Pict:5)>0)
					
					ImgControl_SetPicture("img_control"; ->[Image:1]Pict:5)
					
			End case 
			
		End if 
		
		OBJECT Get pointer:C1124(Object named:K67:5; "img_location")->:=ImgRecord_GetLocation
		
		OBJECT SET ENABLED:C1123(*; "import_pict"; [Image:1]Path:3#"")
		OBJECT SET ENABLED:C1123(*; "import_blob"; [Image:1]Path:3#"")
		
	: ($event=On Unload:K2:2)
		
		ImgControl_Finalize("img_control")
		
	: ($event=On Timer:K2:25)
		
		C_LONGINT:C283($msgCount)
		$msgCount:=ImgControl_ProcessMessages("img_control")
		If ($msgCount=0)
			SET TIMER:C645(0)
		End if 
		
	: ($event=On Resize:K2:27)
		
		ImgControl_UpdateLayout("img_control")
		
	: ($event=On Outside Call:K2:11)
		
		ARRAY OBJECT:C1221($messageQueue; 0)
		ImgRecord_GetMessages(->$messageQueue)
		
		C_LONGINT:C283($idx; $msgCount)
		$msgCount:=Size of array:C274($messageQueue)
		For ($idx; 1; $msgCount)
			
			C_OBJECT:C1216($message)
			$message:=$messageQueue{$idx}
			
			C_TEXT:C284($what)
			$what:=OB Get:C1224($message; "What"; Is text:K8:3)
			
			Case of 
				: ($what="Goto")
					
					C_LONGINT:C283($imageID)
					$imageID:=OB Get:C1224($message; "ID"; Is longint:K8:6)
					If ($imageID#[Image:1]ID:1)
						
						gRecordViewImageID:=$imageID
						
						$idx:=$msgCount+1
						
						ACCEPT:C269
						
					End if 
					
			End case 
			
		End for 
		
End case 

